diff -r aenet-2.0.3/src/aenet.f90 aenet-x2.0.3/src/aenet.f90
74,88c74,90
<   public :: aenet_init,                     &
<             aenet_final,                    &
<             aenet_all_loaded,               &
<             aenet_atomic_energy,            &
<             aenet_atomic_energy_and_forces, &
<             aenet_convert_atom_types,       &
<             aenet_free_atom_energy,         &
<             aenet_load_potential,           &
<             aenet_print_info,               &
<             aenet_nbl_init,                 &
<             aenet_nbl_final,                &
<             aenet_nbl_neighbors,            &
<             aenet_sfb_init,                 &
<             aenet_sfb_final,                &
<             aenet_sfb_eval,                 &
---
>   public :: aenet_init,                            &
>             aenet_final,                           &
>             aenet_all_loaded,                      &
>             aenet_atomic_energy,                   &
>             aenet_atomic_energy_and_forces,        &
>             aenet_atomic_energy_forces_stress,     &
>             aenet_atomic_energy_forces_stress_rep, &              
>             aenet_convert_atom_types,              &
>             aenet_free_atom_energy,                &
>             aenet_load_potential,                  &           
>             aenet_print_info,                      &
>             aenet_nbl_init,                        &
>             aenet_nbl_final,                       &
>             aenet_nbl_neighbors,                   &
>             aenet_sfb_init,                        &
>             aenet_sfb_final,                       &
>             aenet_sfb_eval,                        &
483a486,675
> 
>   subroutine aenet_atomic_energy_forces_stress( &
>        coo_i, type_i, index_i, n_j, coo_j, type_j, index_j, natoms, &
>        E_i, F, sigma, stat) bind(C)
> 
>     implicit none
> 
>     real(kind=c_double), dimension(3),        intent(in)    :: coo_i
>     integer(kind=c_int), value,               intent(in)    :: type_i
>     integer(kind=c_int), value,               intent(in)    :: index_i
>     integer(kind=c_int), value,               intent(in)    :: n_j
>     real(kind=c_double), dimension(3,n_j),    intent(in)    :: coo_j
>     integer(kind=c_int), dimension(n_j),      intent(in)    :: type_j
>     integer(kind=c_int), dimension(n_j),      intent(in)    :: index_j
>     integer(kind=c_int), value,               intent(in)    :: natoms
>     real(kind=c_double),                      intent(out)   :: E_i
>     real(kind=c_double), dimension(3,natoms), intent(inout) :: F
>     real(kind=c_double), dimension(6),        intent(inout) :: sigma    
>     integer(kind=c_int),                      intent(out)   :: stat
> 
>     double precision, dimension(1)                  :: E_i_arr
>     double precision, dimension(:),     allocatable :: sfval
>     double precision, dimension(:,:),   allocatable :: sfderiv_i
>     double precision, dimension(:,:,:), allocatable :: sfderiv_j
>     double precision, dimension(:,:),   allocatable :: sfderiv_s    
>     double precision, dimension(:),     allocatable :: values
>     double precision, dimension(:),     allocatable :: derivs    
>     double precision, dimension(:),     allocatable :: jacobian
>     integer                                         :: nvalues, nweights
>     integer                                         :: nsf, j
>     double precision, dimension(:),     allocatable :: dE_dG
>     integer                                         :: ok
> 
>     stat = AENET_OK
>     if (.not. (aenet_is_init .and. aenet_is_loaded)) then
>        stat = aenet_ERR_INIT
>        return
>     end if
> 
>     nvalues = aenet_pot(type_i)%net%nvalues
>     nweights = aenet_pot(type_i)%net%Wsize
>     allocate(dE_dG(aenet_nsf_max),        &
>              sfval(aenet_nsf_max),        &
>              sfderiv_i(3, aenet_nsf_max), &
>              sfderiv_j(3, aenet_nsf_max, aenet_nnb_max), &
>              sfderiv_s(6, aenet_nsf_max), &             
>              values(nvalues), &
>              derivs(nvalues), &
>              jacobian(nweights), stat=ok)
>     if (ok /= 0) then
>        stat = AENET_ERR_MALLOC
>        return
>     end if
>     sfval(:)         = 0.0d0
>     sfderiv_i(:,:)   = 0.0d0
>     sfderiv_j(:,:,:) = 0.0d0
>     sfderiv_s(:,:)   = 0.0d0
>     
>     nsf = aenet_pot(type_i)%stp%nsf
>     call stp_eval(type_i, coo_i, n_j, coo_j, type_j,        &
>                   aenet_pot(type_i)%stp, sfval=sfval,       &
>                   sfderiv_i=sfderiv_i, sfderiv_j=sfderiv_j, &
>                   sfderiv_s=sfderiv_s, scaled=.true.)
> 
>     call ff_eval(aenet_pot(type_i)%net, nsf, sfval, 1, values, derivs, E_i_arr)
>     call ff_deriv(aenet_pot(type_i)%net, nsf, 1, derivs, jacobian, dE_dG(1:nsf))
> 
>     ! Energy
>     E_i = aenet_pot(type_i)%E_scale*E_i_arr(1) + aenet_pot(type_i)%E_shift
>     E_i = E_i + aenet_pot(type_i)%E_atom
> 
>     ! Forces
>     F(1:3, index_i) = F(1:3, index_i) - aenet_pot(type_i)%E_scale &
>                     * matmul(sfderiv_i(1:3,1:nsf), dE_dG(1:nsf))
> 
>     do j = 1, n_j
>        F(1:3, index_j(j)) = F(1:3, index_j(j)) - aenet_pot(type_i)%E_scale &
>                           * matmul(sfderiv_j(1:3,1:nsf,j), dE_dG(1:nsf))
>     end do
> 
>     ! Stress
>     sigma(1:6) = sigma(1:6) - aenet_pot(type_i)%E_scale &
>                * matmul(sfderiv_s(1:6,1:nsf), dE_dG(1:nsf))  
> 
>     deallocate(dE_dG, sfval, sfderiv_i, sfderiv_j, sfderiv_s, &
>                values, derivs, jacobian, stat=ok)
>     
>     if (ok /= 0) then
>        stat = AENET_ERR_MALLOC
>        return
>     end if
> 
>   end subroutine aenet_atomic_energy_forces_stress
> 
>   subroutine aenet_atomic_energy_forces_stress_rep( &
>        coo_i, type_i, index_i, n_j, coo_j, type_j, index_j, natoms, &
>        rep_parameters, E_i, F, sigma, stat) bind(C)
> 
>     implicit none
> 
>     real(kind=c_double), dimension(3),        intent(in)    :: coo_i
>     integer(kind=c_int), value,               intent(in)    :: type_i
>     integer(kind=c_int), value,               intent(in)    :: index_i
>     integer(kind=c_int), value,               intent(in)    :: n_j
>     real(kind=c_double), dimension(3,n_j),    intent(in)    :: coo_j
>     integer(kind=c_int), dimension(n_j),      intent(in)    :: type_j
>     integer(kind=c_int), dimension(n_j),      intent(in)    :: index_j
>     integer(kind=c_int), value,               intent(in)    :: natoms
>     real(kind=c_double), dimension(2),        intent(in)    :: rep_parameters    
>     real(kind=c_double),                      intent(out)   :: E_i
>     real(kind=c_double), dimension(3,natoms), intent(inout) :: F
>     real(kind=c_double), dimension(6),        intent(inout) :: sigma    
>     integer(kind=c_int),                      intent(out)   :: stat
> 
>     double precision, dimension(1)                  :: E_i_arr
>     double precision, dimension(:),     allocatable :: sfval
>     double precision, dimension(:,:),   allocatable :: sfderiv_i
>     double precision, dimension(:,:,:), allocatable :: sfderiv_j
>     double precision, dimension(:,:),   allocatable :: sfderiv_s      
>     double precision, dimension(:),     allocatable :: values
>     double precision, dimension(:),     allocatable :: derivs    
>     double precision, dimension(:),     allocatable :: jacobian
>     integer                                         :: nvalues, nweights
>     integer                                         :: nsf, j
>     double precision, dimension(:),     allocatable :: dE_dG
>     integer                                         :: ok
> 
>     stat = AENET_OK
>     if (.not. (aenet_is_init .and. aenet_is_loaded)) then
>        stat = aenet_ERR_INIT
>        return
>     end if
> 
>     nvalues = aenet_pot(type_i)%net%nvalues
>     nweights = aenet_pot(type_i)%net%Wsize
>     allocate(dE_dG(aenet_nsf_max),        &
>              sfval(aenet_nsf_max),        &
>              sfderiv_i(3, aenet_nsf_max), &
>              sfderiv_j(3, aenet_nsf_max, aenet_nnb_max), &
>              sfderiv_s(6, aenet_nsf_max), &               
>              values(nvalues), &
>              derivs(nvalues), &
>              jacobian(nweights), stat=ok)
>     if (ok /= 0) then
>        stat = AENET_ERR_MALLOC
>        return
>     end if
>     sfval(:)         = 0.0d0
>     sfderiv_i(:,:)   = 0.0d0
>     sfderiv_j(:,:,:) = 0.0d0
>     sfderiv_s(:,:)   = 0.0d0    
> 
>     nsf = aenet_pot(type_i)%stp%nsf
>     call stp_eval(type_i, coo_i, n_j, coo_j, type_j,        &
>                   aenet_pot(type_i)%stp, sfval=sfval,       &
>                   sfderiv_i=sfderiv_i, sfderiv_j=sfderiv_j, &
>                   sfderiv_s=sfderiv_s, scaled=.true.)!,       &
>                   !rep_p=rep_parameters)
> 
>     call ff_eval(aenet_pot(type_i)%net, nsf, sfval, 1, values, derivs, E_i_arr)
>     call ff_deriv(aenet_pot(type_i)%net, nsf, 1, derivs, jacobian, dE_dG(1:nsf))
> 
>     ! Energy
>     E_i = aenet_pot(type_i)%E_scale*E_i_arr(1) + aenet_pot(type_i)%E_shift
>     E_i = E_i + aenet_pot(type_i)%E_atom !+ repval
> 
>     ! Forces
>     F(1:3, index_i) = F(1:3, index_i) - aenet_pot(type_i)%E_scale &
>                     * matmul(sfderiv_i(1:3,1:nsf), dE_dG(1:nsf))!   &
>                     !+ repderiv_i(1:3))
> 
>     do j = 1, n_j
>        F(1:3, index_j(j)) = F(1:3, index_j(j)) - aenet_pot(type_i)%E_scale &
>                           * matmul(sfderiv_j(1:3,1:nsf,j), dE_dG(1:nsf))!   &
>                           !+ repderiv_j(1:3,j))
>     end do
> 
>     ! Stress
>     sigma(1:6) = sigma(1:6) - aenet_pot(type_i)%E_scale &
>                * matmul(sfderiv_s(1:6,1:nsf), dE_dG(1:nsf)) !- repderiv_s 
> 
>     deallocate(dE_dG, sfval, sfderiv_i, sfderiv_j, sfderiv_s, &
>                values, derivs, jacobian, stat=ok)
>     
>     if (ok /= 0) then
>        stat = AENET_ERR_MALLOC
>        return
>     end if
> 
>   end subroutine aenet_atomic_energy_forces_stress_rep    
diff -r aenet-2.0.3/src/aenet.h aenet-x2.0.3/src/aenet.h
20a21,30
> void aenet_atomic_energy_forces_stress(double coo_i[3], int type_i, int index_i,
>                                     int n_j, double coo_j[], int type_j[],
>                                     int index_j[], int natoms, double* E_i,
>                                     double F[], double sigma[], int* stat);
> 
> void aenet_atomic_energy_forces_stress_rep(double coo_i[3], int type_i, int index_i,
>                                     int n_j, double coo_j[], int type_j[],
> 				    int index_j[], int natoms, double rep_p[], double* E_i,
>                                     double F[], double sigma[], int* stat);
> 
Only in aenet-x2.0.3/src/: analyse.F90
Only in aenet-x2.0.3/src/ext: asciilib.f90
diff -r aenet-2.0.3/src/ext/feedforward.f90 aenet-x2.0.3/src/ext/feedforward.f90
38a39,40
>              ff_fwderiv,             &
>              ff_swderiv,             &
40c42,43
<              ff_activate
---
>              ff_activate,            &             
>              ff_activate_all
431a435,440
>        case(5)
>           fname = 'leaky rectified linear unit  (relu)'
>        case(6)
>           fname = 'softplus (splus)'
>        case(7)
>           fname = 'gaussian (gaus)'              
579c588
<   subroutine ff_eval(net, nx, x, ny, values, derivs, y)
---
>   subroutine ff_eval(net, nx, x, ny, values, derivs, y, derivs2)
588c597
<     double precision, dimension(net%nvalues), intent(out)   :: derivs
---
>     double precision, dimension(net%nvalues), intent(out)   :: derivs  
589a599,602
>     
>     double precision, dimension(net%nvalues), optional, intent(out) :: derivs2      
>     
>    
595a609
>     logical               :: all
613c627
< 
---
>     
636,639c650,662
<        call ff_activate(net%f_a(ilayer+1),          &
<                         work(1:nnodes2),            &
<                         values(iv1:iv1+nnodes2-1),  &
<                         derivs(iv1:iv1+nnodes2-1)   )
---
>        if (.not. present(derivs2)) then
>           call ff_activate(net%f_a(ilayer+1),          &
>                            work(1:nnodes2),            &
>                            values(iv1:iv1+nnodes2-1),  &
>                            derivs(iv1:iv1+nnodes2-1)   )
>        else
>           call ff_activate_all(net%f_a(ilayer+1),          &
>                                work(1:nnodes2),            &
>                                values(iv1:iv1+nnodes2-1),  &
>                                derivs(iv1:iv1+nnodes2-1),  &
>                                derivs2(iv1:iv1+nnodes2-1)  )         
>        end if
>           
855a879,1262
>   !     derivative of the forces nodes with respect to all weights     !
>   !--------------------------------------------------------------------!
>   
>   subroutine ff_fwderiv(net, nw, nx, ny, na, dx_dr, values, derivs, &
>                         derivs2, jacobian, dy_dw)
> 
>     implicit none
> 
>     type(Network),                            intent(inout) :: net
>     integer,                                  intent(in)    :: nw, nx, ny, na
>     double precision, dimension(3, nx, na),   intent(in)    :: dx_dr
> 
>     double precision, dimension(net%nvalues), intent(in)    :: values
>     double precision, dimension(net%nvalues), intent(in)    :: derivs
>     double precision, dimension(net%nvalues), intent(in)    :: derivs2
>     double precision, dimension(net%Wsize),   intent(in)    :: jacobian
>     
>     double precision, dimension(3, na, ny, nw), intent(out)   :: dy_dw
> 
>     integer, dimension(2) :: Wshape
>     integer               :: nnodes0, nnodes1, nnodes2, nnodes3, nnodes12
>     integer               :: ilayer, jlayer, i, jcoo, jatom !, naMax
>     integer               :: iv1, iv2, iw1, iw2, iv0, iw0, iv3
>     integer               :: in0, in1, in2, in3
>   
>     double precision, dimension(net%nvalues-net%nlayers+1)                 :: netv 
>     double precision, dimension(net%nvalues-net%nlayers+1)                 :: netvv 
>     double precision, dimension(net%nvalues-net%nlayers+1)                 :: netw
> 
>     double precision, dimension(net%nvalues-net%nlayers+1, net%nnodes_max) :: netg
>     double precision, dimension(net%nvalues-net%nlayers+1, net%nnodes_max) :: netgp
>     double precision, dimension(net%nvalues-net%nlayers+1, net%nnodes_max) :: netwg
>     double precision, dimension(net%nvalues, net%nnodes_max)               :: netgg
> 
>     double precision, dimension(net%nvalues-net%nlayers+1, net%nnodes_max) :: netgw
>     double precision, dimension(net%nvalues-net%nlayers+1, nx)             :: do_dr
>     double precision, dimension(net%nvalues-net%nlayers+1, nx)             :: dop_dr
>     double precision, dimension(ny, net%nnodes_max)                        :: netprefactor1
>     double precision, dimension(net%nnodes_max+1,net%nnodes_max+1)         :: work2
>     double precision, dimension(net%nnodes_max+1,net%nnodes_max+1)         :: work3
>     double precision, dimension(net%nnodes_max+1,(net%nnodes_max+1)**2)    :: work4
>     double precision, dimension(net%nnodes_max+1,(net%nnodes_max+1)**2)    :: work5    
>     double precision, dimension(net%nlayers, ny, net%nvalues)              :: netback 
>     
>     !set arrays to zero
>     dy_dw         = 0.0d0
>     netv          = 0.0d0
>     netvv         = 0.0d0
>     netg          = 0.0d0
>     netgp         = 0.0d0
>     netw          = 0.0d0
>     netgg         = 0.0d0
>     netwg         = 0.0d0
>     do_dr         = 0.0d0
>     netgw         = 0.0d0
>     netprefactor1 = 0.0d0
>     netback       = 0.0d0
>     
>   
>     do i = 1, nx
>        netg(i,i)  = 1.0d0
>        do_dr(i,i) = 1.0d0
>     end do  
>    
>     iv1 = 1
>     iw1 = 1
>     
>     nnodes0 = nx
>     nnodes1 = nx  
>     nnodes2 = 1
>     layers_f : do ilayer = 1, net%nlayers-1
>        iw2 = net%iw(ilayer+1)
>        iv2 = net%iv(ilayer+1)
> 
>        nnodes2 = net%nnodes(ilayer+1)
>        do i = 1, nnodes2
>           netg(i + iv2 - ilayer, i)  = derivs(iv2 + i)
>           netgp(i + iv2 - ilayer, i) = derivs2(iv2 + i)
>        end do
>  
>        iv0 = 1 + iv2 - ilayer
>        iv3 = nnodes2 + iv2 - ilayer
> 
>        netgw(iv0:iv3, 1:nnodes1) = reshape(jacobian(iw1:iw2-nnodes2), (/ nnodes2, nnodes1 /))
>        netwg(1+iv2-ilayer:nnodes2+iv2-ilayer, 1:nnodes1) = matmul(                            &
>                                      reshape(net%W(iw1:iw2-nnodes2), (/ nnodes2, nnodes1 /)), &
>                                      netg(1-ilayer+iv1:nnodes1+iv1-ilayer,1:nnodes1))
>        do_dr(iv0:iv3, 1:nx) = matmul(netgw(iv0:iv3,1:nnodes1),           &
>                               do_dr(1+iv1-ilayer:nnodes1+iv1-ilayer,1:nx))
>        netgp(iv0:iv3, 1:nnodes1) = matmul(netgp(iv0:iv3, 1:nnodes2),     &
>                   reshape(net%W(iw1:iw2-nnodes2), (/ nnodes2, nnodes1 /)))
> 
>        iv1 = iv2 + 1
>        iw1 = iw2 + 1
>        nnodes1 = nnodes2 
>     end do layers_f
>  
>     do jcoo  = 1, 3
>        do jatom = 1, na
>           
>           netv(1:nx) = dx_dr(jcoo, 1:nx, jatom)
>           iv1 = nx + 1
>           iv0 = 1
>            
>           do ilayer = 1, net%nlayers-1
>              nnodes1       = net%nnodes(ilayer)
>              iv2           =  net%nnodes(ilayer+1) + iv1 - 1
>              netv(iv1:iv2) = matmul(do_dr(iv1:iv2, 1:nx), netv(1:nx))
>              netw(iv1:iv2) = matmul(netgp(iv1:iv2, 1:nnodes1), netv(iv0:iv1-1))
>              iv0           = iv1
>              iv1           = iv2 + 1
>           end do
>             
>           do i = 1, ny
>              netprefactor1(i,i) = 1.0d0 
>           end do
>             
>           iw2     = net%iw(net%nlayers)
>           iv2     = net%iv(net%nlayers) 
>           nnodes2 = net%nnodes(net%nlayers)
>           nnodes3 = net%nnodes(net%nlayers)
> 
>           layers : do ilayer = net%nlayers-1, 1, -1
>              iw1 = net%iw(ilayer) + 1
>              iv1 = net%iv(ilayer) + 1
> 
>              nnodes1   = net%nnodes(ilayer)
>              nnodes12  = (nnodes1 + 1)*nnodes2
>              work5 = 0.0d0
>              work4 = 0.0d0  
>              in0       = 1
> 
>              do in1 = 1, nnodes1
>                 do in2 = 1, nnodes2
>                    work5(in2, in0) = netg(in2 + iv2 - ilayer, in2)*netv(in1 + iv1 - ilayer)
>                    in0             = in0 + 1
>                 end do
>              end do
> 
>              if (ilayer < net%nlayers-1) then
>                 work2 = 0.0d0
>                 do i = 1, nnodes2
>                    work2(i, i) = netw(iv2+i-ilayer)
>                 end do
>                    work3(1:nnodes3,1:nnodes2) = matmul(                            &
>                                                 netprefactor1(1:nnodes3,1:nnodes2),   &
>                                                 work2(1:nnodes2, 1:nnodes2))
> 
>                 if (ilayer <  net%nlayers-2) then
>                    do jlayer = net%nlayers-2, ilayer+1, -1 
> 
>                       work3(1:nnodes3,1:nnodes2) = work3(1:nnodes3,1:nnodes2)+&
>                       netback(jlayer, 1:nnodes3, 1:nnodes2)
>                         
>                    end do
>                 end if
> 
>                 netback(ilayer, 1:nnodes3, 1:nnodes2) = work3(1:nnodes3,1:nnodes2)  
>                 do jlayer = net%nlayers-2, ilayer, -1 
>                    netback(jlayer, 1:nnodes3, 1:nnodes1) = matmul( &
>                         netback(jlayer, 1:nnodes3, 1:nnodes2),     &
>                         netwg(1+iv2-ilayer:nnodes2+iv2-ilayer,1:nnodes1))
>                 end do   
> 
>                 do in3 = 1, nnodes3
>                    in0 = 1
>                    do in1 = 1, nnodes1+1
>                       do in2 = 1, nnodes2
>                          work4(in3,in0) = work3(in3,in2)*values(iv1-1+in1)
>                          in0 = in0 + 1
>                       end do
>                    end do
>                 end do 
> 
>              else
>                 work4(1:nnodes3,1:nnodes12) = 0.0d0
>              end if   
>  
>              dy_dw(jcoo,jatom,1:nnodes3,iw1:iw2) = matmul(        &
>                    netprefactor1(1:nnodes3,1:nnodes2),            &
>                    work5(1:nnodes2,1:nnodes12)) + work4(1:nnodes3,1:nnodes12)
>              netprefactor1(1:nnodes3, 1:nnodes1) = matmul(netprefactor1(1:nnodes3, 1:nnodes2), &
>                           netgw(iv2+1-ilayer:iv2+nnodes2-ilayer,1:nnodes1))
>              iv2 = iv1 - 1
>              iw2 = iw1 - 1
>                
>              nnodes2 = nnodes1
>                
>           end do layers   
>        end do
>     end do
>  
>   end subroutine ff_fwderiv
>   
>   !--------------------------------------------------------------------!
>   !     derivative of the stress nodes with respect to all weights     !
>   !--------------------------------------------------------------------!
>   
>  subroutine ff_swderiv(net, nw, nx, ny, dx_dr, values, derivs, &
>                        derivs2, jacobian, dy_dw)
> 
>     implicit none
>    
>     type(Network),                          intent(inout) :: net
>     integer,                                intent(in)    :: nw, nx, ny
>     double precision, dimension(6, nx),     intent(in)    :: dx_dr
>     
>     double precision, dimension(net%nvalues), intent(in)  :: values
>     double precision, dimension(net%nvalues), intent(in)  :: derivs
>     double precision, dimension(net%nvalues), intent(in)  :: derivs2
>     double precision, dimension(net%Wsize),   intent(in)  :: jacobian
>     
>     double precision, dimension(6, ny, nw), intent(out)   :: dy_dw
> 
>     integer, dimension(2) :: Wshape
>     integer               :: nnodes0, nnodes1, nnodes2, nnodes3, nnodes12
>     integer               :: ilayer, jlayer, i, jcoo, jatom 
>     integer               :: iv1, iv2, iw1, iw2, iv0, iw0, iv3
>     integer               :: in0, in1, in2, in3
>   
>     double precision, dimension(net%nvalues-net%nlayers+1)                 :: netv 
>     double precision, dimension(net%nvalues-net%nlayers+1)                 :: netvv 
>     double precision, dimension(net%nvalues-net%nlayers+1)                 :: netw
> 
>     double precision, dimension(net%nvalues-net%nlayers+1, net%nnodes_max) :: netg
>     double precision, dimension(net%nvalues-net%nlayers+1, net%nnodes_max) :: netgp
>     double precision, dimension(net%nvalues-net%nlayers+1, net%nnodes_max) :: netwg
>     double precision, dimension(net%nvalues, net%nnodes_max)               :: netgg
> 
>     double precision, dimension(net%nvalues-net%nlayers+1, net%nnodes_max) :: netgw
>     double precision, dimension(net%nvalues-net%nlayers+1, nx)             :: do_dr
>     double precision, dimension(net%nvalues-net%nlayers+1, nx)             :: dop_dr
>     double precision, dimension(ny, net%nnodes_max)                        :: netprefactor1
>     double precision, dimension(net%nnodes_max+1,net%nnodes_max+1)         :: work2
>     double precision, dimension(net%nnodes_max+1,net%nnodes_max+1)         :: work3
>     double precision, dimension(net%nnodes_max+1,(net%nnodes_max+1)**2)    :: work4
>     double precision, dimension(net%nnodes_max+1,(net%nnodes_max+1)**2)    :: work5     
>     double precision, dimension(net%nlayers, ny, net%nvalues)              :: netback 
>     
>     !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
>     !set arrays to zero
>     dy_dw         = 0.0d0
>     netv          = 0.0d0
>     netvv         = 0.0d0
>     netg          = 0.0d0
>     netgp         = 0.0d0
>     netw          = 0.0d0
>     netgg         = 0.0d0
>     netwg         = 0.0d0
>     do_dr         = 0.0d0
>     netgw         = 0.0d0
>     netprefactor1 = 0.0d0
>     netback       = 0.0d0
>     
>   
>     do i = 1, nx
>        netg(i,i)  = 1.0d0
>        do_dr(i,i) = 1.0d0
>     end do  
>    
>     iv1 = 1
>     iw1 = 1
>     
>     nnodes0 = nx
>     nnodes1 = nx  
>     nnodes2 = 1
>     
>     layers_f : do ilayer = 1, net%nlayers-1
>        iw2 = net%iw(ilayer+1)
>        iv2 = net%iv(ilayer+1)
> 
>        nnodes2 = net%nnodes(ilayer+1)
>        do i = 1, nnodes2
>           netg(i+iv2-ilayer,i)  = derivs(iv2+i)
>           netgp(i+iv2-ilayer,i) = derivs2(iv2+i)
> 
>        end do
> 
>        iv0 = 1+iv2-ilayer
>        iv3 = nnodes2+iv2-ilayer
> 
>        netgw(iv0:iv3, 1:nnodes1) = reshape(jacobian(iw1:iw2-nnodes2), (/ nnodes2, nnodes1 /))
>        
>        netwg(1+iv2-ilayer:nnodes2+iv2-ilayer, 1:nnodes1) = matmul(                       &
>                                      reshape(net%W(iw1:iw2-nnodes2), (/ nnodes2, nnodes1 /)), & 
>                                      netg(1-ilayer+iv1:nnodes1+iv1-ilayer,1:nnodes1))
>        
>        do_dr(iv0:iv3, 1:nx) = matmul(netgw(iv0:iv3,1:nnodes1), &
>                               do_dr(1+iv1-ilayer:nnodes1+iv1-ilayer,1:nx))
>        
>        netgp(iv0:iv3, 1:nnodes1) = matmul(netgp(iv0:iv3, 1:nnodes2),  &
>                                    reshape(net%W(iw1:iw2-nnodes2), (/ nnodes2, nnodes1 /)))
> 
>        iv1 = iv2 + 1
>        iw1 = iw2 + 1
>        nnodes1 = nnodes2 
>     end do layers_f
>  
>     do jcoo  = 1, 6    
>            netv(1:nx) = dx_dr(jcoo, 1:nx)
>            iv1 = nx + 1
>            iv0 = 1
>            do ilayer = 1, net%nlayers-1
>                nnodes1 = net%nnodes(ilayer)
>                iv2 =  net%nnodes(ilayer+1) + iv1 - 1
>                netv(iv1:iv2) = matmul(do_dr(iv1:iv2, 1:nx), netv(1:nx))
>                netw(iv1:iv2) = matmul(netgp(iv1:iv2, 1:nnodes1), netv(iv0:iv1-1))
>                iv0 = iv1
>                iv1 = iv2 + 1
>            end do
>            do i = 1, ny
>                netprefactor1(i,i) = 1.0d0 
>            end do
>            iw2 = net%iw(net%nlayers)
>            iv2 = net%iv(net%nlayers) 
>            nnodes2 = net%nnodes(net%nlayers)
>            nnodes3 = net%nnodes(net%nlayers)
> 
>            layers : do ilayer = net%nlayers-1, 1, -1
>                iw1 = net%iw(ilayer) + 1
>                iv1 = net%iv(ilayer) + 1
> 
>                nnodes1 = net%nnodes(ilayer)
>                nnodes12 = (nnodes1+1)*nnodes2
>                work5(1:nnodes2,1:nnodes12) = 0.0d0
>                work4 = 0.0d0  
>                in0 = 1
>                do in1 = 1, nnodes1
>                    do in2 = 1, nnodes2
>                        work5(in2,in0) = netg(in2+iv2-ilayer,in2)*netv(in1+iv1-ilayer)
>                        in0 = in0 + 1
>                    end do
>                end do
>      
>                if (ilayer < net%nlayers-1) then
>                   work2 = 0.0d0
>                   do i = 1, nnodes2
>                      work2(i, i) = netw(iv2+i-ilayer)
>                   end do
>                   work3(1:nnodes3,1:nnodes2) = matmul(  &
>                     netprefactor1(1:nnodes3,1:nnodes2),   &
>                     work2(1:nnodes2, 1:nnodes2))
> 
>                   if (ilayer <  net%nlayers-2) then
>                      do jlayer = net%nlayers-2, ilayer+1, -1 
>                         work3(1:nnodes3,1:nnodes2) = work3(1:nnodes3,1:nnodes2)+&
>                         netback(jlayer, 1:nnodes3, 1:nnodes2)
>                      end do
>                   end if
>                   netback(ilayer, 1:nnodes3, 1:nnodes2) = work3(1:nnodes3,1:nnodes2)  
>                   do jlayer = net%nlayers-2, ilayer, -1 
>                      netback(jlayer, 1:nnodes3, 1:nnodes1) = matmul( &
>                           netback(jlayer, 1:nnodes3, 1:nnodes2),     &
>                           netwg(1+iv2-ilayer:nnodes2+iv2-ilayer,1:nnodes1))
>                   end do   
>                   do in3 = 1, nnodes3
>                       in0 = 1
>                       do in1 = 1, nnodes1+1
>                          do in2 = 1, nnodes2
>                              work4(in3,in0) = work3(in3,in2)*values(iv1-1+in1)
>                              in0 = in0 + 1
>                          end do
>                       end do
>                   end do 
>   
>                else
>                   work4(1:nnodes3,1:nnodes12) = 0.0d0
>                end if   
> 
>                dy_dw(jcoo,1:nnodes3,iw1:iw2) = matmul(        &
>                     netprefactor1(1:nnodes3,1:nnodes2),      &
>                     work5(1:nnodes2,1:nnodes12)) + work4(1:nnodes3,1:nnodes12)
>                netprefactor1(1:nnodes3, 1:nnodes1) = matmul(netprefactor1(1:nnodes3,1:nnodes2), &
>                              netgw(iv2+1-ilayer:iv2+nnodes2-ilayer,1:nnodes1))
>                iv2 = iv1 - 1
>                iw2 = iw1 - 1
>                nnodes2 = nnodes1
>            end do layers   
>     end do
> 
>     
>  end subroutine ff_swderiv  
> 
>   !--------------------------------------------------------------------!
865a1273,1275
>   !    'relu', 'r'    --> leaky rectified linear unit                  !
>   !    'splus', 'p'   --> softplus                                     !
>   !    'splus', 'p'   --> gaussian                                     !
898a1309,1314
>     case('relu','r')
>        net%f_a(ilayer) = 5
>     case('splus','p')
>        net%f_a(ilayer) = 6
>     case('gaus','g')
>        net%f_a(ilayer) = 7        
956a1373,1385
>     case(5)
>        y  = max(0.01*x, x)
>        if (x >= 0.0d0) then
>          dy = 1.0d0
>        else
>          dy = 0.01d0
>        end if
>     case(6)
>        y  = log(1.0d0 + exp(x))
>        dy = 1.0d0/(1.0d0 + exp(-x))
>     case(7)
>        y  = exp(-x*x)
>        dy = -2.0d0*x*y
962a1392,1457
> 
>   !--------------------------------------------------------------------!
>   !                 return both: value, 1 and 2 derivatives            !
>   !--------------------------------------------------------------------!
> 
>   elemental subroutine ff_activate_all(t, x, y, dy, ddy) 
> 
>     implicit none
> 
>     integer,          intent(in)  :: t
>     double precision, intent(in)  :: x
>     double precision, intent(out) :: y
>     double precision, intent(out) :: dy
>     double precision, intent(out) :: ddy  
> 
>     double precision :: tanhbx
>     double precision, parameter :: a = 1.7159d0
>     double precision, parameter :: b = 0.666666666666667d0
>     double precision, parameter :: c = 0.1d0
> 
>     select case(t)
>     case(0)
>        y   = x
>        dy  = 1.0
>        ddy = 0.0d0 
>     case(1)
>        y   = tanh(x)
>        dy  = 1.0d0 - y*y
>        ddy = -2.0d0*y*(1.0d0 - y*y) 
>     case(2)
>        y   = 1.0d0/(1.0d0 + exp(-x))
>        dy  = y*(1.0d0 - y)
>        ddy = y*(1.0d0 - 3.0d0*y + 2.0d0*y*y) 
>     case(3)
>        tanhbx = tanh(b*x)
>        y   = a*tanhbx
>        dy  = a*(1.0d0 - tanhbx*tanhbx)*b
>        ddy = -2*a*b*b*tanhbx*(1 - tanhbx)   
>     case(4)
>        tanhbx = tanh(b*x)
>        y   = a*tanhbx + c*x
>        dy  = a*(1.0d0 - tanhbx*tanhbx)*b + c
>        ddy = -2*a*b*b*tanhbx*(1 - tanhbx) 
>     case(5)
>        y    = max(0.01*x, x)
>        if (x >= 0) then   !dy = 1 * (x>0)
>          dy = 1.0d0
>        else
>          dy = 0.01d0
>        end if
>        ddy  = 0.0d0  
>     case(6)
>        y   = log(1.0d0 + exp(x))
>        dy  = 1.0d0/(1.0d0 + exp(-x))
>        ddy = dy*(1.0d0 - dy)
>     case(7)
>        y   = exp(-x*x)
>        dy  = -2.0d0*x*y
>        ddy = -2.0d0*y - dy*2.0d0*x
>     case default
>        y   = 0.0d0
>        dy  = 0.0d0
>        ddy = 0.0d0  
>     end select   
> 
>   end subroutine ff_activate_all  
Only in aenet-x2.0.3/src/ext: mlciflib.f90
diff -r aenet-2.0.3/src/ext/sfbasis.f90 aenet-x2.0.3/src/ext/sfbasis.f90
434c434
<                       values, deriv0, deriv1)
---
>                       values, deriv0, deriv1, deriv2)
447a448
>     double precision, dimension(6,nv),     optional, intent(out)   :: deriv2    
452a454
>     double precision, dimension(:,:), allocatable :: sfb_deriv_s    
468,470c470,472
<     if (present(deriv0) .and. present(deriv1)) then
<        do_deriv = .true.
<        deriv0(:,:) = 0.0d0
---
>     if (present(deriv0) .and. present(deriv1) .and. present(deriv2)) then
>        do_deriv      = .true.
>        deriv0(:,:)   = 0.0d0
471a474
>        deriv2(:,:)   = 0.0d0
474c477,478
<                 sfb_deriv_k(3, sfb%num_values))
---
>                 sfb_deriv_k(3, sfb%num_values), &
>                 sfb_deriv_s(6, sfb%num_values))
493,495c497,502
<                              deriv_i=sfb_deriv_i, deriv_j=sfb_deriv_j)
<              values(i1:i2) = values(i1:i2) + sfb_values(1:N)
<              deriv0(1:3, i1:i2) = deriv0(1:3, i1:i2) + sfb_deriv_i(1:3, 1:N)
---
>                              deriv_i=sfb_deriv_i,         &
>                              deriv_j=sfb_deriv_j,         &
>                              deriv_s=sfb_deriv_s)
>                              
>              values(i1:i2)         = values(i1:i2) + sfb_values(1:N)
>              deriv0(1:3, i1:i2)    = deriv0(1:3, i1:i2) + sfb_deriv_i(1:3, 1:N)
496a504
>              deriv2(1:6, i1:i2)    = deriv2(1:6, i1:i2) + sfb_deriv_s(1:6, 1:N)
510,511c518,519
<                 deriv0(1:3, i1:i2) = deriv0(1:3, i1:i2) &
<                                    + s_j*sfb_deriv_i(1:3, 1:N)
---
>                 deriv0(1:3, i1:i2)    = deriv0(1:3, i1:i2) &
>                                       + s_j*sfb_deriv_i(1:3, 1:N)
513a522,523
>                 deriv2(1:6, i1:i2)    = deriv2(1:6, i1:i2) &
>                                       + s_j*sfb_deriv_s(1:6, 1:N)
533c543,546
<                               deriv_j=sfb_deriv_j, deriv_k=sfb_deriv_k)
---
>                               deriv_j=sfb_deriv_j,                  &
>                               deriv_k=sfb_deriv_k,                  &
>                               deriv_s=sfb_deriv_s)
>              
535c548
<              deriv0(1:3, i1:i2) = deriv0(1:3, i1:i2) + sfb_deriv_i(1:3, 1:N)
---
>              deriv0(1:3, i1:i2)    = deriv0(1:3, i1:i2) + sfb_deriv_i(1:3, 1:N)
537a551
>              deriv2(1:6, i1:i2)    = deriv2(1:6, i1:i2) + sfb_deriv_s(1:6, 1:N)
551,552c565,566
<                 deriv0(1:3, i1:i2) = deriv0(1:3, i1:i2) &
<                                    + s_j*s_k*sfb_deriv_i(1:3, 1:N)
---
>                 deriv0(1:3, i1:i2)    = deriv0(1:3, i1:i2) &
>                                       + s_j*s_k*sfb_deriv_i(1:3, 1:N)
556a571,572
>                 deriv2(1:6, i1:i2)    = deriv2(1:6, i1:i2) &
>                                       + s_j*s_k*sfb_deriv_s(1:6, 1:N)  
562c578
<     if (do_deriv) deallocate(sfb_deriv_i, sfb_deriv_j, sfb_deriv_k)
---
>     if (do_deriv) deallocate(sfb_deriv_i, sfb_deriv_j, sfb_deriv_k, sfb_deriv_s)
755c771
<   subroutine sfb_radial(sfb, R_ij, d_ij, values, deriv_i, deriv_j)
---
>   subroutine sfb_radial(sfb, R_ij, d_ij, values, deriv_i, deriv_j, deriv_s)
765c781,782
< 
---
>     double precision, dimension(:,:), optional, intent(out)   :: deriv_s
>     
768c785
<     integer                              :: i
---
>     integer                              :: i, is
783a801,804
>        forall (is=1:3)
>           deriv_s(is,:)   = -deriv_i(is,:)*R_ij(is)
>           deriv_s(7-is,:) = -deriv_i(max(1,is-1),:)*R_ij(min(3,is+1))
>        end forall
785c806,807
< 
---
>     !if (present(deriv_s)) deriv_s = 0
>     
791c813
<                          deriv_i, deriv_j, deriv_k)
---
>                          deriv_i, deriv_j, deriv_k, deriv_s)
802a825
>     double precision, dimension(:,:), optional, intent(out)   :: deriv_s    
810c833
<     integer                              :: i
---
>     integer                              :: i, is
828,829c851
<        ! d/dR_i (cos_ijk)
<        di_cos_ikj = cos_ijk*(R_ij*id_ij2 + R_ik*id_ik2) - (R_ij+R_ik)*id_ij_ik
---
> 
831a854
> 
834,835c857,860
<        ! d/dR_i (w_ijk)
<        di_w_ijk = -(dfc_j*fc_k*R_ij/d_ij + fc_j*dfc_k*R_ik/d_ik)
---
> 
>        ! d/dR_i (cos_ijk)
>        di_cos_ikj = -(dj_cos_ikj + dk_cos_ikj)
> 
837a863
> 
839a866,869
> 
>        ! d/dR_i (w_ijk)
>        di_w_ijk = -(dj_w_ijk + dk_w_ijk)
>        
842a873
> 
844a876
> 
847a880,884
>        forall (is=1:3)
>           deriv_s(is,:)   = deriv_j(is,:)*R_ij(is) + deriv_k(is,:)*R_ik(is) 
>           deriv_s(7-is,:) = deriv_j(max(1,is-1),:)*R_ij(min(3,is+1)) + &
>                             deriv_k(max(1,is-1),:)*R_ik(min(3,is+1))
>        end forall
849d885
< 
diff -r aenet-2.0.3/src/ext/symmfunc.f90 aenet-x2.0.3/src/ext/symmfunc.f90
304c304,305
<   subroutine sf_fingerprint(type1, Xi, nx, X, typej, n, G, dGi, dGj)
---
>   subroutine sf_fingerprint(type1, Xi, nx, X, typej, n, G, dGi, dGj, &
>                             dGs) !, e_rep, f_rep_i, f_rep_j, s_rep, rep_p)
331a333,339
>     double precision, dimension(6,n),    optional, intent(out) :: dGs
> 
>     !double precision,                    optional, intent(out)   :: e_rep
>     !double precision, dimension(3),      optional, intent(out)   :: f_rep_i
>     !double precision, dimension(3, nx),  optional, intent(out)   :: f_rep_j    
>     !double precision, dimension(6),      optional, intent(out)   :: s_rep
>     !double precision, dimension(2),      optional, intent(in)    :: rep_p    
336c344
<     logical          :: deriv
---
>     logical          :: deriv, repulsive
345a354,359
>     !if (present(e_rep) .and. present(f_rep_i) .and. present(f_rep_j) .and. present(s_rep)) then
>     !   repulsive = .true.
>     !else
>     !   repulsive = .false.
>     !end if     
> 
357a372
>        dGs(1:6,1:n) = 0.0d0
358a374,380
>     
>     !if (repulsive) then
>     !   e_rep   = 0.0d0
>     !   f_rep_i = 0.0d0
>     !   f_rep_j = 0.0d0
>     !   s_rep   = 0.0d0       
>     !end if       
370,372c392,397
<           call sf_G1_update(pij, R1(1:3), Rij, n, G, iG, dGi, dGj(1:3,1:n,j))
<           call sf_G2_update(pij, R1(1:3), Rij, n, G, iG, dGi, dGj(1:3,1:n,j))
<           call sf_G3_update(pij, R1(1:3), Rij, n, G, iG, dGi, dGj(1:3,1:n,j))
---
>           call sf_G1_update(pij, R1(1:3), Rij, n, G, iG, dGi, &
>                             dGj(1:3,1:n,j), dGs(1:6,1:n))
>           call sf_G2_update(pij, R1(1:3), Rij, n, G, iG, dGi, &
>                             dGj(1:3,1:n,j), dGs(1:6,1:n))
>           call sf_G3_update(pij, R1(1:3), Rij, n, G, iG, dGi, &
>                             dGj(1:3,1:n,j), dGs(1:6,1:n))
410,411c435,437
<              call sf_G4_update(tijk, R1(1:3), R2(1:3), R3(1:3), Rij, Rik, Rjk, cost, &
<                                n, G, iG, dGi, dGj(1:3,1:n,j), dGj(1:3,1:n,k))
---
>              call sf_G4_update(tijk, R1(1:3), R2(1:3), R3(1:3), Rij, Rik, &
>                                Rjk, cost, n, G, iG, dGi, dGj(1:3,1:n,j),  &
>                                dGj(1:3,1:n,k), dGs(1:6,1:n))
413c439,440
<                                n, G, iG, dGi, dGj(1:3,1:n,j), dGj(1:3,1:n,k))
---
>                                n, G, iG, dGi, dGj(1:3,1:n,j),          &
>                                dGj(1:3,1:n,k), dGs(1:6,1:n))
421a449,450
>        !if (repulsive) call classical_repulsive(R1(1:3), Rij, n, rep_p, e_rep, &
>        !                                        f_rep_i, f_rep_j(1:3,j), s_rep)
458c487
<   subroutine sf_G1_update(pij, vecRij, Rij, n, G, iG, dGi, dGj)
---
>   subroutine sf_G1_update(pij, vecRij, Rij, n, G, iG, dGi, dGj, dGs)
469a499
>     double precision, dimension(6,n), optional, intent(inout) :: dGs    
471c501
<     integer          :: iG1
---
>     integer          :: iG1, is
473a504,511
>     double precision, dimension(6) :: vecsab
> 
>     if (sf_nG2(1,pij) /= 0) then
>       do is = 1, 3
>          vecsab(is)   = vecRij(is)*Rij*vecRij(is)
>          vecsab(7-is) = vecRij(max(1,is-1))*Rij*vecRij(min(3,is+1))
>       end do
>     end if    
481a520
>        if (present(dGs)) dGs(1:6,iG) = dGs(1:6,iG) + dG1*vecsab(1:6)       
516c555
<   subroutine sf_G2_update(pij, vecRij, Rij, n, G, iG, dGi, dGj)
---
>   subroutine sf_G2_update(pij, vecRij, Rij, n, G, iG, dGi, dGj, dGs)
527a567
>     double precision, dimension(6,n), optional, intent(inout) :: dGs    
529c569
<     integer          :: iG2
---
>     integer          :: iG2, is
531a572
>     double precision, dimension(6) :: vecsab    
532a574,580
>     if (sf_nG2(2,pij) /= 0) then
>       do is = 1, 3
>          vecsab(is)   = vecRij(is)*Rij*vecRij(is)
>          vecsab(7-is) = vecRij(max(1,is-1))*Rij*vecRij(min(3,is+1))
>       end do
>     end if
>     
541a590
>        if (present(dGs)) dGs(1:6,iG) = dGs(1:6,iG) + dG2*vecsab(1:6)       
576c625
<   subroutine sf_G3_update(pij, vecRij, Rij, n, G, iG, dGi, dGj)
---
>   subroutine sf_G3_update(pij, vecRij, Rij, n, G, iG, dGi, dGj, dGs)
587a637
>     double precision, dimension(6,n), optional, intent(inout) :: dGs    
589c639
<     integer          :: iG3
---
>     integer          :: iG3, is
591a642
>     double precision, dimension(6) :: vecsab    
592a644,650
>     if (sf_nG2(3,pij) /= 0) then
>       do is = 1, 3
>          vecsab(is)   = vecRij(is)*Rij*vecRij(is)
>          vecsab(7-is) = vecRij(max(1,is-1))*Rij*vecRij(min(3,is+1))
>       end do
>     end if
>     
600a659
>        if (present(dGs)) dGs(1:6,iG) = dGs(1:6,iG) + dG3*vecsab(1:6)       
680c739
<                           cost, n, G, iG, dGi, dGj, dGk)
---
>                           cost, n, G, iG, dGi, dGj, dGk, dGs)
693a753
>     double precision, dimension(6,n), optional, intent(inout) :: dGs    
695c755
<     integer                        :: iG4
---
>     integer                        :: iG4, is
698a759
>     double precision, dimension(6) :: dG4s, dAj, dAk, vBij, vBik, vBjk    
737c798,818
< 
---
>        if (present(dGs)) then
>  
>           do is = 1, 3
>             vBij(is)   = vecRij(is) * Rij * vecRij(is)
>             vBij(7-is) = vecRij(max(1,is-1)) * Rij * vecRij(min(3,is+1)) 
>             vBik(is)   = vecRik(is) * Rik * vecRik(is)
>             vBik(7-is) = vecRik(max(1,is-1)) * Rik * vecRik(min(3,is+1)) 
>             vBjk(is)   = vecRjk(is) * Rjk * vecRjk(is)
>             vBjk(7-is) = vecRjk(max(1,is-1)) * Rjk * vecRjk(min(3,is+1)) 
>             dAj(is)    = dF1j(is) * Rij * vecRij(is)
>             dAj(7-is)  = dF1j(max(1,is-1)) * Rij * vecRij(min(3,is+1))
>             dAk(is)    = dF1k(is) * Rik * vecRik(is)
>             dAk(7-is)  = dF1k(max(1,is-1)) * Rik * vecRik(min(3,is+1))
>          end do
>     
>           dG4s(1:6) = (dAj(1:6) + dAk(1:6)) * F2ij * F2ik * F2jk &
>                        + F1 * (dF2ij*vBij(1:6)) * F2ik * F2jk    &
>                        + F1 * F2ij * (dF2ik*vBik(1:6)) * F2jk    &
>                        + F1 * F2ij * F2ik * (dF2jk*vBjk(1:6))
>           dGs(1:6,iG) = dGs(1:6,iG) + 2.0d0*dG4s(1:6)
>        end if
747c828
<                           G, iG, dGi, dGj, dGk)
---
>                           G, iG, dGi, dGj, dGk, dGs)
760a842
>     double precision, dimension(6,n), optional, intent(inout) :: dGs    
762c844
<     integer                        :: iG5
---
>     integer                        :: iG5, is
765a848
>     double precision, dimension(6) :: dG5s, dAj, dAk, vBij, vBik    
801c884,899
< 
---
>        if (present(dGs)) then
>           do is = 1, 3
>             vBij(is)   = vecRij(is)*Rij*vecRij(is)
>             vBij(7-is) = vecRij(max(1,is-1))*Rij*vecRij(min(3,is+1)) 
>             vBik(is)   = vecRik(is)*Rik*vecRik(is)
>             vBik(7-is) = vecRik(max(1,is-1))*Rik*vecRik(min(3,is+1)) 
>             dAj(is)    = dF1j(is)*Rij*vecRij(is)
>             dAj(7-is)  = dF1j(max(1,is-1))*Rij*vecRij(min(3,is+1))
>             dAk(is)    = dF1k(is)*Rik*vecRik(is)
>             dAk(7-is)  = dF1k(max(1,is-1))*Rik*vecRik(min(3,is+1))
>           end do
>           dG5s(1:6)   = (dAj(1:6) + dAk(1:6)) * F2ij * F2ik  &
>                         + F1 * (dF2ij*vBij(1:6)) * F2ik      &
>                         + F1 * F2ij * (dF2ik*vBik(1:6)) 
>           dGs(1:6,iG) = dGs(1:6,iG) + 2.0d0*dG5s(1:6)
>        end if
808a907,936
>   subroutine classical_repulsive(vecRij, Rij, n, rep_parameters, &
>                                  e_rep, f_rep_i, f_rep_j, s_rep)
>     implicit none
> 
>     double precision, dimension(3),             intent(in)    :: vecRij
>     double precision,                           intent(in)    :: Rij
>     integer,                                    intent(in)    :: n
>     double precision, dimension(2),             intent(in)    :: rep_parameters
> 
>     double precision,                           intent(inout)   :: e_rep
>     double precision, dimension(3),             intent(inout)   :: f_rep_i
>     double precision, dimension(3),             intent(inout)   :: f_rep_j    
>     double precision, dimension(6),             intent(inout)   :: s_rep    
> 
>     double precision               :: epsilon, rzero, r2, c12, cbig
>     double precision, dimension(3) :: f_rep    
>     double precision, dimension(6) :: vecsab
> 
>     integer :: is
>     
>     epsilon = rep_parameters(1) !1.00d0
>     rzero   = rep_parameters(2) !1.5d0
> 
>     r2  = Rij*Rij    
>     c12 = (rzero**2 / r2)**6
> 
>     do is = 1, 3
>          vecsab(is)   = vecRij(is)*vecRij(is)
>          vecsab(7-is) = vecRij(max(1,is-1))*vecRij(min(3,is+1))
>     end do
809a938,947
>     e_rep = e_rep + epsilon*c12
>     
>     f_rep = 12*epsilon*c12/Rij*vecRij
>     f_rep_i = f_rep_i - f_rep
>     f_rep_j = f_rep_j + f_rep    
>   
>     s_rep = s_rep + 12*epsilon*c12*vecsab
> 
>     
>   end subroutine classical_repulsive
831a970,989
> 
>   subroutine sf_cut2(Rij, Rc, fc, dfc)
> 
>     implicit none
> 
>     double precision, intent(in)  :: Rij, Rc
>     double precision, intent(out) :: fc, dfc
> 
>     double precision :: fib
> 
>     if (Rij >= Rc) then
>        fc  = 0.0d0
>        dfc = 0.0d0
>     else
>        fib = (1.0d0 - Rij*Rij/(Rc*Rc))
>        fc  = fib**3
>        dfc = -6.0d0*Rij*fib*fib/(Rc*Rc)
>     end if
> 
>   end subroutine sf_cut2  
diff -r aenet-2.0.3/src/ext/xsflib.f90 aenet-x2.0.3/src/ext/xsflib.f90
83a84,85
>   double precision, dimension(6),                public :: strCart  
> 
85a88
>   logical,                                       public :: hasStress  
112c115,116
< 
---
>     character(len=1)             :: char_temp
>     
121a126
>     hasStress  = .false.    
166a172,178
>        ! stress in Voigt notation
>        if (index(line, 'Stress') > 0) then
>           read(line, *) char_temp, strCart(1:6)
>           hasStress  = .true.
>           cycle read_input
>        end if
>        
diff -r aenet-2.0.3/src/generate.f90 aenet-x2.0.3/src/generate.f90
40a41
>                       strCart,           &
42a44,45
>                       hasStress,         &
>                       volume,            &
131a135
>   integer,           dimension(:),   allocatable :: nblist
135a140,141
>   double precision, dimension(:,:,:), allocatable :: sfderiv_f
>   double precision, dimension(:,:),   allocatable :: sfderiv_s 
149a156
>   character(len=1024)                            :: file_form 
155c162
<   integer :: i
---
>   integer :: i, j, nsf
159a167,168
>   double precision   :: sum_forces, Struc_weight
> 
184c193
<   allocate(nbcoo(3,nnb_max), nbdist(nnb_max), nbtype(nnb_max))
---
>   allocate(nbcoo(3,nnb_max), nblist(nnb_max), nbdist(nnb_max), nbtype(nnb_max))
191,193c200,204
<   allocate(sfval(nsf_max), sfderiv_i(3,nsf_max), sfderiv_j(3,nsf_max,nnb_max))
<   sfval(:) = 0.0d0
<   sfderiv_i(:,:) = 0.0d0
---
>   allocate(sfval(nsf_max), sfderiv_i(3,nsf_max), sfderiv_j(3,nsf_max,nnb_max), &
>            sfderiv_f(3,nsf_max,nnb_max), sfderiv_s(6,nsf_max))
>   
>   sfval(:)         = 0.0d0
>   sfderiv_i(:,:)   = 0.0d0
194a206,207
>   sfderiv_f(:,:,:) = 0.0d0
>   sfderiv_s(:,:)   = 0.0d0  
247c260
<        'N', 'nAtoms', 'nTypes', 'E/atom', 'structure file (xsf)'
---
>        'N', 'nAtoms', 'nTypes', 'E/atom', 'structure file '
255a269
>      file_form = cooFile(index(cooFile, ".", BACK=.true.) + 1:) 
257c271
<      call geo_init(cooFile, 'xsf')
---
>      call geo_init(cooFile, file_form)
259,260c273,274
<      if (.not. (hasForces .and. hasEnergy)) then
<         write(0,*) ">>>", hasForces, hasEnergy
---
>      if (.not. (hasForces .and. hasEnergy .and. hasStress)) then
>         write(0,*) ">>>", hasForces, hasEnergy, hasStress
293a308,318
>      ! Weight for structures based on forces
>      if (inp%structure_force_weight) then
>         sum_forces = 0.0d0
>         do iatom = 1, nAtoms
>            sum_forces = sum_forces + sum(forCart(iatom)**2)
>         end do
>         Struc_weight = 0.2d0/(0.2d0 + sum_forces/dble(nAtoms))
>      else
>         Struc_weight = 1.0d0
>      end if
> 
295c320,322
<      call ts_write_structure_info(ts, cooFile, nAtoms, nTypes, E_coh)
---
>      call ts_write_structure_info(ts, cooFile, nAtoms, nTypes, E_coh, & 
>                                   Struc_weight, strCart, volume)
> 
312c339
< 
---
>   
315c342
< 
---
>         
318c345,346
<         call lcl_nbdist_cart(iatom, nnb, nbcoo, nbdist, r_cut=r_max, nbtype=nbtype)
---
>         call lcl_nbdist_cart(iatom, nnb, nbcoo, nbdist, r_cut=r_max, &
>                              nblist=nblist, nbtype=nbtype)
336c364,377
<                       stp(itype1), sfval=sfval)
---
>                       stp(itype1), sfval=sfval,                   & 
>                       sfderiv_i=sfderiv_i, sfderiv_j=sfderiv_j,   &
>                       sfderiv_s=sfderiv_s)
> 
>         nsf = stp(itype1)%nsf
>         sfderiv_f = 0.0d0
>         sfderiv_f(1:3,1:nsf,iatom) = sfderiv_i(1:3,1:nsf)      
>         !repderiv_f(1:3,iatom)      = repderiv_i(1:3)
>         
>         do j = 1, nnb
>            sfderiv_f(1:3,1:nsf,nblist(j)) = sfderiv_f(1:3,1:nsf,nblist(j)) + &
>                                                       sfderiv_j(1:3,1:nsf,j)
>            !repderiv_f(1:3,nbtype(j))          = repderiv_f(1:3,nbtype(j)) + repderiv_j(1:3,j) 
>         end do
344a386
>    
349c391,393
<         call ts_write_sf_info(ts, stp(itype1)%nsf, sfval(1:stp(itype1)%nsf))
---
>         call ts_write_sf_info(ts, nsf, nAtoms, sfval(1:nsf), &
>                               sfderiv_f(1:3,1:nsf,1:nAtoms), sfderiv_s(1:6,1:nsf)) !,          &
>                               !repval, repderiv_f, repderiv_s)
378c422
<   deallocate(nbcoo, nbdist, nbtype)
---
>   deallocate(nbcoo, nbdist, nbtype, nblist)
diff -r aenet-2.0.3/src/geometry.f90 aenet-x2.0.3/src/geometry.f90
82a83
>   double precision,       dimension(6),                public :: strCart
83a85,86
>   logical,                                             public :: hasStress  
>   
86a90,91
>   double precision,                                    public :: volume    
> 
117a123
>     hasStress = .false.    
121a128,131
>     case('ascii')           
>        call geo_init_ascii(file)
>     case('mlcif')
>        call geo_init_mlcif(file)       
260,261c270,271
<                        pbc, forCart, cohesiveEnergy, totalEnergy, &
<                        comment, fileformat, file, unit)
---
>                        pbc, forCart, strten, cohesiveEnergy,      &
>                        totalEnergy, comment, fileformat, file, unit)
289a300
>     double precision, dimension(6),   optional, intent(in) :: strten    
335c346,350
<        if (present(forCart)) then
---
>        if (present(forCart) .and. present(strten)) then
>           call geo_write_xyz(u, nAtoms, nTypes, cooLatt, atomType,    &
>                              typeName, latticeVec, E_coh, E_tot, cmt, &
>                              forces=forCart, strten=strten)         
>        elseif (present(forCart)) then
662a678
>                        hasStress_in    => hasStress,    &                      
665a682
>                        strCart_in      => strCart,      &                       
682a700
>     volume          = geo_cell_volume(latticeVec)     
684c702,703
< 
---
>     strCart(:)      = strCart_in(:)
>     
688c707,708
< 
---
>     hasStress = hasStress_in
>     
732a753,934
>   !                             XSF format                             !
>   !                                                                    !
>   ! The length unit in the XSF format is Angstrom, so no need to       !
>   ! convert anything.  Energies and forces are assumed to be in eV and !
>   ! eV/Angstrom.                                                       !
>   !--------------------------------------------------------------------!
> 
>   subroutine geo_init_ascii(file)
> 
>     use asciilib, only: ascii_init,                      &
>                         ascii_final,                     &
>                         latticeVec_in   => latticeVec,   &
>                         nAtoms_in       => nAtoms,       &
>                         nTypes_in       => nTypes,       &
>                         atomType_in     => atomType,     &
>                         hasForces_in    => hasForces,    &
>                         hasStress_in    => hasStress,    &                      
>                         atomTypeName_in => atomTypeName, &
>                         forCart_in      => forCart,      &
>                         cooCart_in      => cooCart,      &
>                         strCart_in      => strCart,      &                       
>                         pbc_in          => pbc,          &
>                         hasOutput,                       &
>                         E_coh, E_tot
> 
>     implicit none
> 
>     character(len=*), intent(in) :: file
> 
>     call ascii_init(file)
> 
>     pbc = pbc_in
>     if (pbc) then
>        latticeVec(:,:) = latticeVec_in(:,:)
>        origin = (/ 0.0d0, 0.0d0, 0.0d0 /)
>     else
>        call geo_get_bounds(cooCart_in, latticeVec, origin)
>     end if
>     volume = geo_cell_volume(latticeVec)     
>     recLattVec(:,:) = geo_recip_lattice(latticeVec)
>     strCart(:) = strCart_in(:)
>     
>     nAtoms    = nAtoms_in
>     nTypes    = nTypes_in
>     hasForces = hasForces_in
>     hasStress = hasStress_in
>     
>     if ((nAtoms == 0) .or. (nTypes == 0)) then
>        write(0,*) "Error: invalid input file: ", trim(file)
>        write(0,*) "       nAtoms = ", trim(io_adjustl(nAtoms))
>        write(0,*) "       nTypes = ", trim(io_adjustl(nTypes))
>        call ascii_final()
>        stop
>     end if
> 
>     if (hasForces) then
>        allocate(cooLatt(3,nAtoms), forLatt(3,nAtoms), &
>                 atomType(nAtoms), atomTypeName(nTypes))
>     else
>        allocate(cooLatt(3,nAtoms), atomType(nAtoms),  &
>                 atomTypeName(nTypes))
>     end if
> 
>     atomType(:)     = atomType_in(:)
>     atomTypeName(:) = atomTypeName_in(:)
> 
>     ! convert cartesian coordinates to lattice coordinates:
>     cooLatt(1:3,1:nAtoms) = matmul(recLattVec, cooCart_in)/(2.0d0*PI)
> 
>     ! if forces are available, convert them too:
>     if (hasForces) then
>        forLatt(1:3,1:nAtoms) = matmul(recLattVec, forCart_in)/(2.0d0*PI)
>     end if
> 
>     ! store cohesive energy, if available
>     if (hasOutput) then
>        cohesiveEnergy = E_coh
>        totalEnergy    = E_tot
>        hasEnergy      = .true.
>     else
>        cohesiveEnergy = 0.0d0
>        totalEnergy    = 0.0d0
>        hasEnergy      = .false.
>     end if
> 
>     call ascii_final
> 
>   end subroutine geo_init_ascii
> 
> 
>   !--------------------------------------------------------------------!
>   !                             XSF format                             !
>   !                                                                    !
>   ! The length unit in the XSF format is Angstrom, so no need to       !
>   ! convert anything.  Energies and forces are assumed to be in eV and !
>   ! eV/Angstrom.                                                       !
>   !--------------------------------------------------------------------!
> 
>   subroutine geo_init_mlcif(file)
> 
>     use mlciflib,  only: mlcif_init,                        &
>                          mlcif_final,                       &
>                          latticeVec_in   => latticeVec,   &
>                          nAtoms_in       => nAtoms,       &
>                          nTypes_in       => nTypes,       &
>                          atomType_in     => atomType,     &
>                          hasForces_in    => hasForces,    &
>                          hasStress_in    => hasStress,    &                      
>                          atomTypeName_in => atomTypeName, &
>                          forCart_in      => forCart,      &
>                          cooCart_in      => cooCart,      &
>                          strCart_in      => strCart,      &                       
>                          pbc_in          => pbc,          &
>                          hasOutput,                       &
>                          E_coh, E_tot
> 
>     implicit none
> 
>     character(len=*), intent(in) :: file
> 
>     call mlcif_init(file)
> 
>     pbc = pbc_in
>     if (pbc) then
>        latticeVec(:,:) = latticeVec_in(:,:)
>        origin = (/ 0.0d0, 0.0d0, 0.0d0 /)
>     else
>        call geo_get_bounds(cooCart_in, latticeVec, origin)
>     end if
>     volume = geo_cell_volume(latticeVec)     
>     recLattVec(:,:) = geo_recip_lattice(latticeVec)
>     strCart(:) = strCart_in(:)
>     
>     nAtoms    = nAtoms_in
>     nTypes    = nTypes_in
>     hasForces = hasForces_in
>     hasStress = hasStress_in
>     
>     if ((nAtoms == 0) .or. (nTypes == 0)) then
>        write(0,*) "Error: invalid input file: ", trim(file)
>        write(0,*) "       nAtoms = ", trim(io_adjustl(nAtoms))
>        write(0,*) "       nTypes = ", trim(io_adjustl(nTypes))
>        call mlcif_final()
>        stop
>     end if
> 
>     if (hasForces) then
>        allocate(cooLatt(3,nAtoms), forLatt(3,nAtoms), &
>                 atomType(nAtoms), atomTypeName(nTypes))
>     else
>        allocate(cooLatt(3,nAtoms), atomType(nAtoms),  &
>                 atomTypeName(nTypes))
>     end if
> 
>     atomType(:)     = atomType_in(:)
>     atomTypeName(:) = atomTypeName_in(:)
> 
>     ! convert cartesian coordinates to lattice coordinates:
>     cooLatt(1:3,1:nAtoms) = matmul(recLattVec, cooCart_in)/(2.0d0*PI)
> 
>     ! if forces are available, convert them too:
>     if (hasForces) then
>        forLatt(1:3,1:nAtoms) = matmul(recLattVec, forCart_in)/(2.0d0*PI)
>     end if
> 
>     ! store cohesive energy, if available
>     if (hasOutput) then
>        cohesiveEnergy = E_coh
>        totalEnergy    = E_tot
>        hasEnergy      = .true.
>     else
>        cohesiveEnergy = 0.0d0
>        totalEnergy    = 0.0d0
>        hasEnergy      = .false.
>     end if
> 
>     call mlcif_final
> 
>   end subroutine geo_init_mlcif
>   
> 
>   !--------------------------------------------------------------------!
738c940
<                            forces)
---
>                            forces, strten)
751a954
>     double precision, dimension(6),        optional, intent(in) :: strten    
768a972
>     if (present(strten)) dummy = .true.    
diff -r aenet-2.0.3/src/input.f90 aenet-x2.0.3/src/input.f90
141a142
> 
177a179,191
> 
>      logical                                             :: structure_force_weight
>      character(6)                                        :: case_string
>      logical                                             :: use_ascii
>      logical                                             :: repulsive
>      double precision,       dimension(2)                :: repulsive_p
>      double precision,       dimension(3)                :: trn_w_obj
>      character(len=PATHLEN), dimension(:),   allocatable :: trn_str_pattern
>      double precision,       dimension(:),   allocatable :: trn_str_weights
>      logical                                             :: trn_ref 
>      integer                                             :: trn_str_psize     
>          
> 
217a232
> 
232a248
>      
241a258,268
>     inp%case_string            = 'energy'
>     inp%structure_force_weight = .false.
>     inp%use_ascii              = .false.
>     inp%repulsive              = .false.
>     inp%repulsive_p(1)         = 1.0d0
>     inp%repulsive_p(2)         = 1.5d0
>     inp%trn_w_obj              = 1.0d0
>     inp%trn_ref                = .false.
>     inp%trn_str_psize          = 0
> 
> 
289a317,320
>     call inp_read_value(u, 'structure_force_weight', inp%structure_force_weight)
>     call inp_read_value(u, 'repulsive_epsilon', inp%repulsive_p(1))   
>     call inp_read_value(u, 'repulsive_rzero',   inp%repulsive_p(2)) 
> 
316a348
>     call inp_read_case_string(inp, u, iline)
317a350,351
>     call inp_read_w_objectives(inp, u, iline)
>     call inp_read_weights_block(inp, u, iline)    
328a363,367
>     call inp_read_value(u, 'use_ascii',         inp%use_ascii)
>     call inp_read_value(u, 'repulsive',         inp%repulsive)    
>     call inp_read_value(u, 'train_reference',   inp%trn_ref)
>    
> 
374a414,418
>     call inp_read_value(u, 'use_ascii', inp%use_ascii) 
>     call inp_read_value(u, 'repulsive', inp%repulsive)
>     call inp_read_value(u, 'repulsive_epsilon', inp%repulsive_p(1))    !should not be here
>     call inp_read_value(u, 'repulsive_rzero',   inp%repulsive_p(2))
> 
478a523,525
>     if (allocated(inp%trn_str_pattern)) deallocate(inp%trn_str_pattern)
>     if (allocated(inp%trn_str_weights)) deallocate(inp%trn_str_weights)   
> 
699,767c746,818
<     call inp_find_keyword(unit, 'method', iline)
<     if (iline > 0) then
<        call aeio_readline(unit, iline, line)
<        read(line,*) inp%trn_method
<        select case(trim(io_lower(inp%trn_method)))
<        case('bfgs')
<           inp%trn_methodName = 'Limited Memory BFGS'
<        case('ekf')
<           inp%trn_methodName = 'Extended Kalman Filter'
<           inp%trn_nparams = 6
<           allocate(inp%trn_param(inp%trn_nparams))
<           inp%trn_param(1) = 0.999d0
<           call io_readval(line, 'lambda', inp%trn_param(1))
<           inp%trn_param(2) = 0.97d0
<           call io_readval(line, 'lambda0', inp%trn_param(2))
<           inp%trn_param(3) = 10.0d0
<           call io_readval(line, 'state', inp%trn_param(3))
<           inp%trn_param(4) = 0.0d0
<           call io_readval(line, 'pnoise', inp%trn_param(4))
<           inp%trn_param(5) = 0.6d0
<           call io_readval(line, 'adaptive', inp%trn_param(5))
<           inp%trn_param(6) = 100.0
<           call io_readval(line, 'wgroup', inp%trn_param(6))
<        case('lm')
<           inp%trn_methodName = 'Levenberg-Marquardt'
<           inp%trn_nparams = 5
<           allocate(inp%trn_param(inp%trn_nparams))
<           inp%trn_param(1) = 1000.0d0
<           call io_readval(line, 'batchsize', inp%trn_param(1))
<           inp%trn_param(2) = 0.1d0
<           call io_readval(line, 'learnrate', inp%trn_param(2))
<           inp%trn_param(3) = 1.0d0
<           call io_readval(line, 'iter', inp%trn_param(3))
<           inp%trn_param(4) = 1.0d-3
<           call io_readval(line, 'conv', inp%trn_param(4))
<           inp%trn_param(5) = 10.0d0
<           call io_readval(line, 'adjust', inp%trn_param(5))
<        case('online_sd','online_gd')
<           inp%trn_methodName = 'Gradient Descent (online)'
<           inp%trn_nparams = 2
<           allocate(inp%trn_param(inp%trn_nparams))
<           inp%trn_param(1) = 0.01d0
<           call io_readval(line, 'alpha', inp%trn_param(1))
<           inp%trn_param(2) = 0.9d0
<           call io_readval(line, 'gamma', inp%trn_param(2))
<        case('adam')
<           ! mu: learning rate
<           ! b1: decay rate for gradient average
<           ! b2: decay rate for squared gradient average
<           ! eps: small number to prevent division by zero
<           ! sample: size of stochastic sample for each epoch
<           inp%trn_methodName = 'Adaptive Moment Estimation (Adam)'
<           inp%trn_nparams = 6
<           allocate(inp%trn_param(inp%trn_nparams))
<           inp%trn_param(1) = 0.001d0
<           call io_readval(line, 'mu', inp%trn_param(1))
<           inp%trn_param(2) = 0.9d0
<           call io_readval(line, 'b1', inp%trn_param(2))
<           inp%trn_param(3) = 0.999d0
<           call io_readval(line, 'b2', inp%trn_param(3))
<           inp%trn_param(4) = 1.0d-8
<           call io_readval(line, 'eps', inp%trn_param(4))
<           inp%trn_param(5) = 500.0d0
<           call io_readval(line, 'samplesize', inp%trn_param(5))
<           inp%trn_param(6) = 1.0d0
<           call io_readval(line, 'batchsize', inp%trn_param(6))
<           ! Adam should not be used with sequential sampling
<           inp%trn_sampling = 'random'
<        end select
---
>     if (inp%case_string == "energy") then
>        call inp_find_keyword(unit, 'method', iline)
>        if (iline > 0) then
>           call aeio_readline(unit, iline, line)
>           read(line,*) inp%trn_method
>           select case(trim(io_lower(inp%trn_method)))
>           case('bfgs')
>              inp%trn_methodName = 'Limited Memory BFGS'
>           case('ekf')
>              inp%trn_methodName = 'Extended Kalman Filter'
>              inp%trn_nparams = 6
>              allocate(inp%trn_param(inp%trn_nparams))
>              inp%trn_param(1) = 0.999d0
>              call io_readval(line, 'lambda', inp%trn_param(1))
>              inp%trn_param(2) = 0.97d0
>              call io_readval(line, 'lambda0', inp%trn_param(2))
>              inp%trn_param(3) = 10.0d0
>              call io_readval(line, 'state', inp%trn_param(3))
>              inp%trn_param(4) = 0.0d0
>              call io_readval(line, 'pnoise', inp%trn_param(4))
>              inp%trn_param(5) = 0.6d0
>              call io_readval(line, 'adaptive', inp%trn_param(5))
>              inp%trn_param(6) = 100.0
>              call io_readval(line, 'wgroup', inp%trn_param(6))
>           case('lm')
>              inp%trn_methodName = 'Levenberg-Marquardt'
>              inp%trn_nparams = 5
>              allocate(inp%trn_param(inp%trn_nparams))
>              inp%trn_param(1) = 1000.0d0
>              call io_readval(line, 'batchsize', inp%trn_param(1))
>              inp%trn_param(2) = 0.1d0
>              call io_readval(line, 'learnrate', inp%trn_param(2))
>              inp%trn_param(3) = 1.0d0
>              call io_readval(line, 'iter', inp%trn_param(3))
>              inp%trn_param(4) = 1.0d-3
>              call io_readval(line, 'conv', inp%trn_param(4))
>              inp%trn_param(5) = 10.0d0
>              call io_readval(line, 'adjust', inp%trn_param(5))
>           case('online_sd','online_gd')
>              inp%trn_methodName = 'Gradient Descent (online)'
>              inp%trn_nparams = 2
>              allocate(inp%trn_param(inp%trn_nparams))
>              inp%trn_param(1) = 0.01d0
>              call io_readval(line, 'alpha', inp%trn_param(1))
>              inp%trn_param(2) = 0.9d0
>              call io_readval(line, 'gamma', inp%trn_param(2))
>           case('adam')
>              ! mu: learning rate
>              ! b1: decay rate for gradient average
>              ! b2: decay rate for squared gradient average
>              ! eps: small number to prevent division by zero
>              ! sample: size of stochastic sample for each epoch
>              inp%trn_methodName = 'Adaptive Moment Estimation (Adam)'
>              inp%trn_nparams = 6
>              allocate(inp%trn_param(inp%trn_nparams))
>              inp%trn_param(1) = 0.001d0
>              call io_readval(line, 'mu', inp%trn_param(1))
>              inp%trn_param(2) = 0.9d0
>              call io_readval(line, 'b1', inp%trn_param(2))
>              inp%trn_param(3) = 0.999d0
>              call io_readval(line, 'b2', inp%trn_param(3))
>              inp%trn_param(4) = 1.0d-8
>              call io_readval(line, 'eps', inp%trn_param(4))
>              inp%trn_param(5) = 500.0d0
>              call io_readval(line, 'samplesize', inp%trn_param(5))
>              inp%trn_param(6) = 1.0d0
>              call io_readval(line, 'batchsize', inp%trn_param(6))
>              ! Adam should not be used with sequential sampling
>              inp%trn_sampling = 'random'
>           end select
>        else
>           if (present(stat)) stat = S_NOT
>        end if
769,771c820,821
<        if (present(stat)) stat = S_NOT
<     end if
< 
---
>        inp%trn_methodName = 'Limited Memory BFGS'
>     end if   
1173a1224,1385
> 
>   subroutine inp_read_case_string(inp, unit, iline, stat)
> 
>     implicit none
> 
>     type(InputData),   intent(inout) :: inp
>     integer,           intent(in)    :: unit
>     integer,           intent(out)   :: iline
>     integer, optional, intent(out)   :: stat
> 
>     character(LINELEN)    :: line
>     integer, dimension(3) :: mode
>     integer               :: i, smode
>       
>     
>     if (present(stat)) stat = S_OK
> 
>     call inp_find_keyword(unit, 'mode', iline, line)
>    
>     if (iline > 0) then
>        line = line(5:)
>        mode(1) = scan(line, "E")
>        mode(2) = scan(line, "F")
>        mode(3) = scan(line, "S")
>        do i = 1, size(mode)
>           if (mode(i) > 0) mode(i) = i
>        end do
>        smode = sum(mode) 
>        if (smode == 6) then
>           inp%case_string = "trnAll"
>        elseif (smode == 5) then
>           inp%case_string = "FlinkS"
>        elseif (smode == 4) then
>           inp%case_string = "ElinkS"
>        elseif (smode == 3) then
>           if (mode(2) > 0) then
>              inp%case_string = "ElinkF"
>           else
>              inp%case_string = "stress"
>           end if
>        elseif (smode == 2) then
>           inp%case_string = "forces"
>        end if   
>     end if
> 
>   end subroutine inp_read_case_string
> 
>   !--------------------------------------------------------------------!
>   
>   subroutine inp_read_w_objectives(inp, unit, iline, stat)
> 
>     implicit none
> 
>     type(InputData),   intent(inout) :: inp
>     integer,           intent(in)    :: unit
>     integer,           intent(out)   :: iline
>     integer, optional, intent(out)   :: stat
> 
>     character(LINELEN)             :: line
>     double precision, dimension(3) :: weights
>     integer                        :: i
>     
>     if (present(stat)) stat = S_OK
> 
>     call inp_find_keyword(unit, 'wobjectives', iline, line)
>     if (iline > 0) then
>        line = line(12:)
>        weights = 1
>        call io_readval(line, 'alpha', weights(1))
>        call io_readval(line, 'beta', weights(2))
>        call io_readval(line, 'gamma', weights(3))
>        do i = 1, 3
>           if (weights(i)<0 .or. weights(i)>1000) then
>              write(*,*) "Weights of the objective should be between 0 and 1000"
>              write(*,*) "Using default values"
>              weights = 1.0d0
>           end if   
>        end do   
>     else
>        weights = 1
>     end if
> 
>     inp%trn_w_obj = weights
>   end subroutine inp_read_w_objectives
> 
>   !--------------------------------------------------------------------!
> 
>   subroutine inp_find_keyword2(unit, keyword, iline, line)
> 
>     implicit none
> 
>     integer,                          intent(in)  :: unit
>     character(len=*),                 intent(in)  :: keyword
>     integer,                          intent(out) :: iline
>     character(len=LINELEN), optional, intent(out) :: line
> 
>     integer                :: stat
>     character(len=LINELEN) :: kwd, ln
> 
>     rewind(unit)
>     kwd = ''
>     iline = 0
>     skip : do
>        call aeio_readline(unit, iline, ln, stat)
>        if (stat /= 0) then
>           ! end of file and keyword not found
>           iline = 0
>           exit skip
>        end if
>        iline = iline + 1
>        read(ln, *) kwd
>        !write(*,*) index(trim(io_lower(kwd)), trim(io_lower(keyword))), &
>        !           trim(io_lower(kwd))," ",  trim(io_lower(keyword))
>        if (index(trim(io_lower(kwd)), trim(io_lower(keyword))) > 0) then
>           ! keyword found
>           if (present(line)) line = ln
>           exit skip
>        end if
>     end do skip
> 
>   end subroutine inp_find_keyword2   
>   
>   subroutine inp_read_weights_block(inp, unit, iline, stat)
> 
>     implicit none
> 
>     type(InputData),   intent(inout) :: inp
>     integer,           intent(in)    :: unit
>     integer,           intent(out)   :: iline
>     integer, optional, intent(out)   :: stat
> 
>     character(LINELEN) :: line, line_end
> 
>     double precision   :: weight
>     character(LINELEN) :: pattern
>     integer            :: sblock, iblock
> 
>     if (present(stat)) stat = S_OK
> 
>     line_end = "}"
>     sblock = 0
>     call inp_find_keyword2(unit, 'STRUCTURE_WEIGHTS', iline, line)
>     if (iline > 0) then
>        weights_block : do
>           call aeio_readline(unit, iline, line, stat)
>           if ( index(trim(line), trim(line_end)) > 0) exit weights_block
>           sblock = sblock + 1
>        end do weights_block
> 
>        allocate(inp%trn_str_pattern(sblock), inp%trn_str_weights(sblock))
>        inp%trn_str_psize = sblock
>        call inp_find_keyword2(unit, 'STRUCTURE_WEIGHTS', iline, line)
>        do iblock = 1, sblock
>           call aeio_readline(unit, iline, line, stat)
>           read(line,*) inp%trn_str_pattern(iblock), inp%trn_str_weights(iblock)
>           !write(*,*) trim(inp%trn_str_pattern(iblock)), inp%trn_str_weights(iblock)
>        end do        
>     else
>        if (present(stat)) stat = S_NOT
>     end if
>     
>   end subroutine inp_read_weights_block
diff -r aenet-2.0.3/src/Makefile.inc aenet-x2.0.3/src/Makefile.inc
29c29,30
<            sfbasis.o sfsetup.o sortlib.o symmfunc.o timing.o trainset.o xsflib.o
---
>            sfbasis.o sfsetup.o sortlib.o symmfunc.o timing.o trainset.o \
>            xsflib.o asciilib.o mlciflib.o
35c36,37
<               symmfunc_pic.o timing_pic.o trainset_pic.o xsflib_pic.o
---
>               symmfunc_pic.o timing_pic.o trainset_pic.o xsflib_pic.o \
>               asciilib_pic.o mlciflib_pic.o
45c47,48
< TARGETS  = $(TARGET1) $(TARGET2) $(TARGET3)
---
> TARGET4  = $(BIN)analyse.x
> TARGETS  = $(TARGET1) $(TARGET2) $(TARGET3) $(TARGET4)
59a63
> analyse  : $(TARGET4)
81c85
< 	$(LD) $(LDFLAGS) -o $@-$(version)-$(SUFFIX) $< $(OBJECTS) $(LIB) $(NUMLIB)
---
> 	$(LD) -g $(LDFLAGS) -o $@-$(version)-$(SUFFIX) $< $(OBJECTS) $(LIB) $(NUMLIB)
84c88
< 	$(LD) $(LDFLAGS) -o $@-$(version)-$(SUFFIX) $< $(OBJECTS) $(LIB) $(NUMLIB)
---
> 	$(LD) -g $(LDFLAGS) -o $@-$(version)-$(SUFFIX) $< $(OBJECTS) $(LIB) $(NUMLIB)
120c124
< geometry.o    : aeio.o constants.o io.o xsflib.o
---
> geometry.o    : aeio.o constants.o io.o xsflib.o asciilib.o mlciflib.o
129a134,135
> asciilib.o    : io.o
> mlciflib.o    : io.o
Only in aenet-x2.0.3/src/: ooo
diff -r aenet-2.0.3/src/optimize.f90 aenet-x2.0.3/src/optimize.f90
712c712
<   subroutine opt_after_sample(net, ts, dE, Dw)
---
>   subroutine opt_after_sample(net, ts, dE, dF, dS, Dw, DwF, DwS, nAtoms)
716,719c716,729
<     type(Network),    dimension(:),   intent(inout) :: net
<     type(TrnSet),                     intent(in)    :: ts
<     double precision,                 intent(in)    :: dE
<     double precision, dimension(:,:), intent(in)    :: Dw
---
>     type(Network),    dimension(:),                 intent(inout) :: net
>     type(TrnSet),                                   intent(in)    :: ts
>     
>     double precision,                     optional, intent(in)    :: dE
>     double precision, dimension(:,:),     optional, intent(in)    :: dF
>     double precision, dimension(:),       optional, intent(in)    :: dS
>     
>     double precision, dimension(:,:),     optional, intent(in)    :: Dw
>     double precision, dimension(:,:,:,:), optional, intent(in)    :: DwF
>     double precision, dimension(:,:,:),   optional, intent(in)    :: DwS
> 
>     integer,                              optional, intent(in)    :: nAtoms    
> 
>     integer :: icoo, jcoo
723c733,735
<     opt_SSE = opt_SSE + 0.5d0*dE*dE
---
>     if (present(dE)) opt_SSE = opt_SSE + 0.5d0*dE*dE
>     if (present(dF)) opt_SSE = opt_SSE + 0.5d0*sum(dF*dF)
>     if (present(dS)) opt_SSE = opt_SSE + 0.5d0*sum(dS*dS)   
727c739,753
<        bfgs_Dw_sum(:,:)  = bfgs_Dw_sum(:,:) + dE*Dw(:,:)
---
>        if (present(dE)) bfgs_Dw_sum(:,:)  = bfgs_Dw_sum(:,:) + dE*Dw(:,:)
> 
>        if (present(dF)) then
>           do icoo = 1, 3
>              do jcoo = 1, nAtoms
>                 bfgs_Dw_sum(:,:)  = bfgs_Dw_sum(:,:) + &
>                                     dF(icoo, jcoo)*DwF(icoo, jcoo, :, :)
>              end do
>           end do    
>        end if
>        if (present(dS)) then
>           do icoo = 1, 6
>              bfgs_Dw_sum(:,:)  = bfgs_Dw_sum(:,:) + dS(icoo)*DwS(icoo, :, :)          
>           end do
>        end if   
1597c1623
<     bfgs_iprint = -1
---
>     bfgs_iprint = -1 !2024 !-1
1605,1606c1631,1632
<     inquire(file=OPT_STATE_FILE, exist=fexists)
<     if (fexists) call opt_load_state(file=OPT_STATE_FILE)
---
>     !inquire(file=OPT_STATE_FILE, exist=fexists)
>     !if (fexists) call opt_load_state(file=OPT_STATE_FILE)
diff -r aenet-2.0.3/src/parallel.F90 aenet-x2.0.3/src/parallel.F90
475a476,477
>     call pp_send(ts%nAtomsMax, dest)
>     call pp_send(ts%normalization, dest)
510a513,514
>     call pp_recv(ts%nAtomsMax)
>     call pp_recv(ts%normalization)    
718a723,739
>     call pp_send(inp%case_string, dest)
>     call pp_send(inp%structure_force_weight, dest)
>     call pp_send(inp%use_ascii, dest)
>     call pp_send(inp%repulsive, dest)
>     call pp_send(inp%repulsive_p, 2, dest)    
>     call pp_send(inp%trn_w_obj, 3, dest)
>     call pp_send(inp%trn_ref, dest)
>     call pp_send(inp%trn_str_psize, dest)
>     
>     isalloc = allocated(inp%trn_str_pattern)
>     call pp_send(isalloc, dest)
>     if (isalloc) call pp_send(inp%trn_str_pattern, inp%trn_str_psize, dest)
> 
>     isalloc = allocated(inp%trn_str_weights)
>     call pp_send(isalloc, dest)
>     if (isalloc) call pp_send(inp%trn_str_weights, inp%trn_str_psize, dest)    
>     
827a849,872
> 
>     call pp_recv(inp%case_string)
>     call pp_recv(inp%structure_force_weight)
>     call pp_recv(inp%use_ascii)
>     call pp_recv(inp%repulsive)
> 
>     call pp_recv(inp%repulsive_p, 2)
>     call pp_recv(inp%trn_w_obj, 3)
> 
>     call pp_recv(inp%trn_ref)
>     call pp_recv(inp%trn_str_psize)
>     
>     
>     call pp_recv(isalloc)
>     if (isalloc) then
>        allocate(inp%trn_str_pattern(inp%trn_str_psize))
>        call pp_recv(inp%trn_str_pattern, inp%trn_str_psize)
>     end if
> 
>     call pp_recv(isalloc)
>     if (isalloc) then
>        allocate(inp%trn_str_weights(inp%trn_str_psize))
>        call pp_recv(inp%trn_str_weights, inp%trn_str_psize)
>     end if    
diff -r aenet-2.0.3/src/predict.F90 aenet-x2.0.3/src/predict.F90
22,23c22,23
<   use aeio,      only: aeio_header,                    &
<                        aeio_timestamp,                 &
---
>   use aeio,      only: aeio_header,                           &
>                        aeio_timestamp,                        &
26,34c26,36
<   use aenet,     only: aenet_init,                     &
<                        aenet_final,                    &
<                        aenet_atomic_energy,            &
<                        aenet_atomic_energy_and_forces, &
<                        aenet_convert_atom_types,       &
<                        aenet_free_atom_energy,         &
<                        aenet_load_potential,           &
<                        aenet_print_info,               &
<                        aenet_Rc_min, aenet_Rc_max,     &
---
>   use aenet,     only: aenet_init,                            &
>                        aenet_final,                           &
>                        aenet_atomic_energy,                   &
>                        aenet_atomic_energy_and_forces,        &
>                        aenet_atomic_energy_forces_stress,     &
>                        aenet_atomic_energy_forces_stress_rep, &                        
>                        aenet_convert_atom_types,              &
>                        aenet_free_atom_energy,                &
>                        aenet_load_potential,                  &
>                        aenet_print_info,                      &
>                        aenet_Rc_min, aenet_Rc_max,            &
39,49c41,51
<   use geometry,  only: geo_init,                       &
<                        geo_final,                      &
<                        pbc,                            &
<                        latticeVec,                     &
<                        recLattVec,                     &
<                        geo_update_bounds,              &
<                        origin,                         &
<                        nAtoms,                         &
<                        nTypes,                         &
<                        atomType,                       &
<                        atomTypeName,                   &
---
>   use geometry,  only: geo_init,                              &
>                        geo_final,                             &
>                        pbc,                                   &
>                        latticeVec,                            &
>                        recLattVec,                            &
>                        geo_update_bounds,                     &
>                        origin,                                &
>                        nAtoms,                                &
>                        nTypes,                                &
>                        atomType,                              &
>                        atomTypeName,                          &
52c54
<   use input,     only: InputData,                      &
---
>   use input,     only: InputData,                             &
57,59c59,61
<   use lclist,    only: lcl_init,                       &
<                        lcl_final,                      &
<                        lcl_nmax_nbdist,                &
---
>   use lclist,    only: lcl_init,                              &
>                        lcl_final,                             &
>                        lcl_nmax_nbdist,                       &
62,63c64,65
<   use optimize,  only: opt_init,                       &
<                        opt_final,                      &
---
>   use optimize,  only: opt_init,                              &
>                        opt_final,                             &
66,73c68,75
<   use parallel,  only: pp_init,                        &
<                        pp_final,                       &
<                        pp_bcast,                       &
<                        pp_bcast_coo,                   &
<                        pp_print_info,                  &
<                        pp_bcast_InputData,             &
<                        pp_bcast_latt,                  &
<                        pp_sum,                         &
---
>   use parallel,  only: pp_init,                               &
>                        pp_final,                              &
>                        pp_bcast,                              &
>                        pp_bcast_coo,                          &
>                        pp_print_info,                         &
>                        pp_bcast_InputData,                    &
>                        pp_bcast_latt,                         &
>                        pp_sum,                                &
118a121,123
>   character(len=1024)                           :: file_form  
>   double precision, dimension(6)                :: stress
> 
160c165,168
<         call geo_init(cooFile, 'xsf')
---
>         
>         file_form = cooFile(index(cooFile, ".", BACK=.true.) + 1:)
>         call geo_init(cooFile, file_form)
>         
195c203,205
<                         Ecoh, Etot, forCart=forCart, atomicEnergy=atomicEnergy)
---
>                         Ecoh, Etot, forCart=forCart, strten=stress, &
>                         rep=inp%repulsive, rep_p=inp%repulsive_p,   &
>                         atomicEnergy=atomicEnergy)
198c208,209
<                         Ecoh, Etot, forCart=forCart)
---
>                         Ecoh, Etot, forCart=forCart, strten=stress, &
>                         rep=inp%repulsive, rep_p=inp%repulsive_p)
283c294
<            call print_energy(Ecoh, Etot, forCart)
---
>            call print_energy(Ecoh, Etot, forCart, stress)
536c547
<   subroutine print_energy(Ecoh, Etot, forCart)
---
>   subroutine print_energy(Ecoh, Etot, forCart, strCart)
541a553,554
>     double precision, dimension(:),   optional, intent(in) :: strCart
>     
559,560c572,581
<     write(*,*)
< 
---
>     if (present(strCart)) then    
>        write(*,*)
>        write(*,*) "Stress  (eV/Ang3)"
>        write(*,'(3(2x,A21))') "sigmaxx",  "sigmayy", "sigmazz"
>        write(*,*) strCart(1:3)
>        write(*,'(3(2x,A21))') "sigmayz", "sigmaxz", "sigmaxy"
>        write(*,*) strCart(4:6)
>        write(*,*)        
>     end if
>     
567,568c588,590
<   subroutine get_energy(latticeVec, nAtoms, cooLatt, atomType, &
<                         pbc, Ecoh, Etot, forCart, atomicEnergy)
---
>   subroutine get_energy(latticeVec, nAtoms, cooLatt, atomType,  &
>                         pbc, Ecoh, Etot, forCart, atomicEnergy, &
>                         strten, rep, rep_p)
581a604,607
>     double precision, dimension(6),        optional, intent(out) :: strten
>     logical,                               optional, intent(in)  :: rep    
>     double precision, dimension(2),        optional, intent(in)  :: rep_p    
> 
583c609
<     double precision, dimension(3,nAtoms) :: forCart_num
---
>     double precision, dimension(3,nAtoms)         :: forCart_num
585,586c611,612
<     double precision :: d
<     double precision, dimension(3,3) :: dd
---
>     double precision                              :: d
>     double precision, dimension(3,3)              :: dd
590c616
<     logical                                       :: do_F, do_E_atom
---
>     logical                                       :: do_F, do_E_atom, do_rep
600c626
<     double precision                              :: E_i
---
>     double precision                              :: E_i, vol
606c632,633
<     if (do_F) forCart(1:3,1:nAtoms) = 0.0d0
---
>     if (do_F) forCart(1:3,1:nAtoms)       = 0.0d0
>     if (do_F) strten(1:6)                 = 0.0d0    
607a635
>     if (present(rep)) do_rep              = rep
611a640,646
>     vol = latticeVec(1,1)*latticeVec(2,2)*latticeVec(3,3) &
>         + latticeVec(2,1)*latticeVec(3,2)*latticeVec(1,3) &
>         + latticeVec(3,1)*latticeVec(1,2)*latticeVec(2,3) &
>         - latticeVec(3,1)*latticeVec(2,2)*latticeVec(1,3) &
>         - latticeVec(1,1)*latticeVec(3,2)*latticeVec(2,3) &
>         - latticeVec(2,1)*latticeVec(1,2)*latticeVec(3,3)
> 
636,638c671,679
<           call aenet_atomic_energy_and_forces( &
<                coo_i, type_i, iatom, nnb, nbcoo, nbtype, nblist, &
<                nAtoms, E_i, forCart, stat)
---
>           if (do_rep) then
>              call aenet_atomic_energy_forces_stress_rep( &
>                    coo_i, type_i, iatom, nnb, nbcoo, nbtype, nblist, &
>                    nAtoms, rep_p, E_i, forCart, strten, stat) 
>           else
>              call aenet_atomic_energy_forces_stress( &
>                    coo_i, type_i, iatom, nnb, nbcoo, nbtype, nblist, &
>                    nAtoms, E_i, forCart, strten, stat) 
>           end if             
690a732
>        strten(1:6) = - strten(1:6) / vol 
694a737
>           call pp_sum(strten(1:6), 6)
diff -r aenet-2.0.3/src/sfsetup.f90 aenet-x2.0.3/src/sfsetup.f90
880,881c880,883
<   subroutine stp_eval(itype0, coo0, n, coo1, type1, stp, sfval, &
<                       sfderiv_i, sfderiv_j, scaled)
---
>   subroutine stp_eval(itype0, coo0, n, coo1, type1, stp, sfval,       &
>                       sfderiv_i, sfderiv_j, scaled, sfderiv_s) !,  &
>                       !repval, repderiv_i(1:3), repderiv_j(1:3,1:n),   &
>                       !repderiv_s(1:6), rep_p)   )
894a897
>     double precision, dimension(:,:),   optional, intent(out)   :: sfderiv_s    
905c908
<     if (present(sfderiv_i) .and. present(sfderiv_j)) then
---
>     if (present(sfderiv_i) .and. present(sfderiv_j) .and. present(sfderiv_s)) then
929c932
<                         sfderiv_j(1:3,1:nsf,1:n))
---
>                         sfderiv_j(1:3,1:nsf,1:n), sfderiv_s(1:6,1:nsf))
939c942
<                               sfderiv_j(1:3,1:nsf,1:n))
---
>                               sfderiv_j(1:3,1:nsf,1:n), sfderiv_s(1:6,1:nsf))
945a949
> 
948c952,953
<           call stp_normalize(stp, sfval, sfderiv_i, sfderiv_j, n)
---
>           call stp_normalize(stp, sfval, sfderiv_i, sfderiv_j, &
>                              sfderiv_s=sfderiv_s, n=n)
978c983,984
<   subroutine stp_normalize(stp, sfval, sfderiv_i, sfderiv_j, n)
---
>   subroutine stp_normalize(stp, sfval, sfderiv_i, sfderiv_j, &
>                            sfderiv_f, sfderiv_s, n)
987a994,996
>     double precision, dimension(:,:,:), optional, intent(out)   :: sfderiv_f
>     double precision, dimension(:,:),   optional, intent(out)   :: sfderiv_s    
> 
990c999,1000
<     logical          :: do_deriv
---
>     logical          :: do_deriv, do_deriv2
> 
992c1002,1006
<     if (present(sfderiv_i) .and. present(sfderiv_j) .and. present(n)) then
---
>     do_deriv  = .false.
>     do_deriv2 = .false.
>     
>     if (present(sfderiv_i) .and. present(sfderiv_j) .and. &
>         present(sfderiv_s) .and. present(n)) then
994,995c1008,1010
<     else
<        do_deriv = .false.
---
>     elseif (present(sfderiv_f) .and. present(sfderiv_s) .and. &
>             present(n)) then
>        do_deriv2 = .true.
1021a1037
> 
1023c1039
<           sfderiv_i(1:3,isf) = scale*sfderiv_i(1:3,isf)
---
>           sfderiv_i(1:3,isf)     = scale*sfderiv_i(1:3,isf)
1024a1041,1044
>           sfderiv_s(1:6,isf)     = scale*sfderiv_s(1:6,isf)
>        elseif (do_deriv2) then
>           sfderiv_f(1:3,isf,1:n) = scale*sfderiv_f(1:3,isf,1:n)
>           sfderiv_s(1:6,isf)     = scale*sfderiv_s(1:6,isf)
1025a1046
>                         
diff -r aenet-2.0.3/src/train.f90 aenet-x2.0.3/src/train.f90
31a32
>                          save_Network_ASCII,     &                         
32a34
>                          load_Network_ASCII,     &                         
40c42,44
<                          ff_wderiv
---
>                          ff_wderiv,              &
>                          ff_fwderiv,             & 
>                          ff_swderiv             
92a97
>                          save_Setup_ASCII,       &
108a114
>                          save_TrnSet_info_ASCII,  &
216a223
>   double precision,  dimension(:),     allocatable :: ann_derivs2  
231a239,253
>   integer                                            :: nAtoms
>   double precision,  dimension(:,:,:,:), allocatable :: Dwf
>   double precision,  dimension(:,:,:),   allocatable :: DwS
>   double precision,  dimension(:,:),     allocatable :: dF
>   double precision,  dimension(6)                    :: dS
> 
>   double precision                                   :: wfactor
>   double precision                                   :: sqrt_beta_three
>   double precision                                   :: wfactor_e    
>   double precision                                   :: wfactor_f
>   double precision                                   :: wfactor_s
>   double precision                                   :: nNorm_trn
>   double precision                                   :: nNorm_tst  
>   
>   
247c269
<         ! load training set
---
>         ! load training set        
264a287
>      
278d300
< 
280,281c302,304
<   allocate(ann_values(nnodes_max), &
<            ann_derivs(nnodes_max), &
---
>   allocate(ann_values(nnodes_max),  &
>            ann_derivs(nnodes_max),  &
>            ann_derivs2(nnodes_max), &
299d321
< 
308c330,333
<      call ts_print_info(ts)
---
>      call ts_print_info(ts)  
>      wfactor_e       = sqrt(inp%trn_w_obj(1))    
>      sqrt_beta_three = sqrt(inp%trn_w_obj(2)/3.0d0)
>      wfactor_s       = sqrt(inp%trn_w_obj(3)/6.0d0)
316c341,344
< 
---
>   call pp_bcast(wfactor_e)
>   call pp_bcast(sqrt_beta_three)
>   call pp_bcast(wfactor_s)
>   
321,322c349,368
<   call distribute_trnfile(isTest, nsf_max, ts, ts_trn, ts_tst)
< 
---
>   call distribute_trnfile(isTest, nsf_max, ts, ts_trn, ts_tst)  
>   
>   nNorm_trn = ts_trn%normalization
>   nNorm_tst = ts_tst%normalization
>   if (ppSize>1) then
>      call pp_sum(nNorm_trn)
>      call pp_sum(nNorm_tst)
>   end if   
>   nNorm_trn = 1.0d0/nNorm_trn
>   nNorm_tst = 1.0d0/nNorm_tst
>   if (nNorm_trn+1 .eq. nNorm_trn) nNorm_trn = 0
>   if (nNorm_tst+1 .eq. nNorm_tst) nNorm_tst = 0
>   if (ppMaster) then
>     write(*,*) 'Normalization factor    : '
>     write(*,*) '  train 1/N             : ', nNorm_trn
>     write(*,*) '  test  1/N             : ', nNorm_tst
>     write(*,*)     
>   end if 
>   
>   
332a379
>   
337c384,387
<   allocate(Dw(nw_max,ts%nTypes))
---
>   allocate(Dw(nw_max,ts%nTypes),                  &
>            DwF(3,ts%nAtomsMax,nw_max,ts%nTypes),  &
>            DwS(6,nw_max,ts%nTypes),               &     
>            dF(3,ts%nAtomsMax) ) 
347,349c397,399
<      call print_training_header(inp%trn_steps, inp%trn_methodName)
< 
<   call eval_entire_trainset(ts_trn, nTrain, nsf_max, nw_max, net, &
---
>      call print_training_header(inp%trn_steps, inp%trn_methodName, inp%case_string)
>   
>   call eval_entire_trainset(inp%case_string, ts_trn, nNorm_trn, nsf_max, nw_max, net, &
351c401
<   call eval_entire_trainset(ts_tst, nTest, nsf_max, nw_max, net, &
---
>   call eval_entire_trainset(inp%case_string, ts_tst, nNorm_tst, nsf_max, nw_max, net, &
355,356c405,408
<        MAE_trn/ts_trn%scale, sqrt(2.0d0*SSE_trn/dble(nTrain))/ts_trn%scale, &
<        MAE_tst/ts_trn%scale, sqrt(2.0d0*SSE_tst/dble(nTest))/ts_tst%scale)
---
>        !MAE_trn/ts_trn%scale, sqrt(2.0d0*SSE_trn/dble(nTrain))/ts_trn%scale, &
>        !MAE_tst/ts_trn%scale, sqrt(2.0d0*SSE_tst/dble(nTest))/ts_tst%scale)
>        MAE_trn/ts_trn%scale, sqrt(2.0d0*SSE_trn*nNorm_trn)/ts_trn%scale, &
>        MAE_tst/ts_trn%scale, sqrt(2.0d0*SSE_tst*nNorm_tst)/ts_tst%scale  )  
393c445
< 
---
>         
405c457,492
<               call eval_next_structure(ts_trn, nsf_max, nw_max, net, dE, Dw=Dw)
---
>               select case(inp%case_string)
>                    case("energy")
>                       call eval_next_structure(ts_trn, nsf_max, nw_max, net, &
>                                                wfactor, dE=dE, Dw=Dw,        &
>                                                do_pattern_weight=.true.)
>                    case("forces")                     
>                       call eval_next_structure(ts_trn, nsf_max, nw_max, net, &
>                                                wfactor, dF=dF, DwF=DwF,      &
>                                                nAtomsOut=nAtoms,             &
>                                                do_pattern_weight=.true.)
>                    case("stress")                      
>                       call eval_next_structure(ts_trn, nsf_max, nw_max, net, &
>                                                wfactor, dS=dS, DwS=DwS,      &
>                                                do_pattern_weight=.true.)
>                    case("ElinkF")
>                       call eval_next_structure(ts_trn, nsf_max, nw_max, net, &
>                                                wfactor, dE=dE, Dw=Dw, dF=dF, &
>                                                DwF=DwF, nAtomsOut=nAtoms,    &
>                                                do_pattern_weight=.true.)
>                    case("ElinkS")
>                       call eval_next_structure(ts_trn, nsf_max, nw_max, net, &
>                                                wfactor, dE=dE, Dw=Dw, dS=dS, &
>                                                DwS=DwS, do_pattern_weight=.true.)
>                    case("FlinkS")
>                       call eval_next_structure(ts_trn, nsf_max, nw_max, net, &
>                                                wfactor, dF=dF, DwF=DwF,      &
>                                                dS=dS, DwS=DwS,               &
>                                                nAtomsOut=nAtoms,             &
>                                                do_pattern_weight=.true.)
>                    case("trnAll")
>                       call eval_next_structure(ts_trn, nsf_max, nw_max, net, &
>                                                wfactor, dE=dE, Dw=Dw, dF=dF, &
>                                                DwF=DwF, dS=dS, DwS=DwS,      &
>                                                nAtomsOut=nAtoms,             &
>                                                do_pattern_weight=.true.)
>               end select        
408c495,528
<               call eval_next_structure(ts_trn, nsf_max, nw_max, net, dE)
---
>               select case(inp%case_string)
>                    case("energy")                
>                       call eval_next_structure(ts_trn, nsf_max, nw_max, net, &
>                                                wfactor, dE=dE,               &
>                                                do_pattern_weight=.true.)
>                    case("forces")
>                       call eval_next_structure(ts_trn, nsf_max, nw_max, net, &
>                                                wfactor, dF=dF,               &
>                                                nAtomsOut=nAtoms,             &
>                                                do_pattern_weight=.true.) 
>                    case("stress")
>                       call eval_next_structure(ts_trn, nsf_max, nw_max, net, &
>                                                wfactor, dS=dS,               &
>                                                do_pattern_weight=.true.)                      
>                    case("ElinkF")
>                       call eval_next_structure(ts_trn, nsf_max, nw_max, net, &
>                                                wfactor, dE=dE, dF=dF,        &
>                                                nAtomsOut=nAtoms,             &
>                                                do_pattern_weight=.true.)
>                    case("ElinkS")
>                       call eval_next_structure(ts_trn, nsf_max, nw_max, net, &
>                                                wfactor, dE=dE, dS=dS,        &
>                                                do_pattern_weight=.true.)
>                    case("FlinkS")
>                       call eval_next_structure(ts_trn, nsf_max, nw_max, net, &
>                                                wfactor, dF=dF, dS=dS,        &
>                                                nAtomsOut=nAtoms,             &
>                                                do_pattern_weight=.true.)                     
>                    case("trnAll")
>                       call eval_next_structure(ts_trn, nsf_max, nw_max, net, &
>                                                wfactor, dE=dE, dF=dF, dS=dS, &
>                                                nAtomsOut=nAtoms,             &
>                                                do_pattern_weight=.true.)                      
>                 end select      
409a530,531
>            wfactor = sqrt(wfactor*nNorm_trn)
>            if (nAtoms > 0) wfactor_f = sqrt_beta_three/sqrt(dble(nAtoms))
411c533,578
<            call opt_after_sample(net, ts, dE, Dw)
---
>            
>            select case(inp%case_string)
>               case("energy")
>                  call opt_after_sample(net, ts, dE=wfactor*dE*wfactor_e,          &
>                                        Dw=wfactor*Dw*wfactor_e)
>                    
>               case("forces")
>                  call opt_after_sample(net, ts,                                   &
>                                        dF=wfactor*dF(:,1:nAtoms)*wfactor_f,       &
>                                        DwF=wfactor*DwF(:,1:nAtoms,:,:)*wfactor_f, &
>                                        nAtoms=nAtoms)               
>               case("stress")               
>                  call opt_after_sample(net, ts, dS=wfactor*dS*wfactor_s,          &
>                                        DwS=wfactor*DwS*wfactor_s)
>                    
>               case("ElinkF")                  
>                  call opt_after_sample(net, ts, dE=wfactor*dE*wfactor_e,          &
>                                        Dw=wfactor*Dw*wfactor_e,                   &
>                                        dF=wfactor*dF(:,1:nAtoms)*wfactor_f,       &
>                                        DwF=wfactor*DwF(:,1:nAtoms,:,:)*wfactor_f, &
>                                        nAtoms=nAtoms)                     
> 
>               case("ElinkS")
>                  call opt_after_sample(net, ts, dE=wfactor*dE*wfactor_e,          &
>                                        Dw=wfactor*Dw*wfactor_e,                   &
>                                        dS=wfactor*dS*wfactor_s,                   &
>                                        DwS=wfactor*DwS*wfactor_s)
>                        
>                    
>               case("FlinkS")                  
>                  call opt_after_sample(net, ts,                                   &
>                                        dF=wfactor*dF(:,1:nAtoms)*wfactor_f,       &
>                                        DwF=wfactor*DwF(:,1:nAtoms,:,:)*wfactor_f, &
>                                        dS=wfactor*dS*wfactor_s,                   &
>                                        DwS=wfactor*DwS*wfactor_s,                 &
>                                        nAtoms=nAtoms)                   
>                    
>               case("trnAll")                
>                  call opt_after_sample(net, ts, dE=wfactor*dE*wfactor_e,          &
>                                        Dw=wfactor*Dw*wfactor_e,                   &
>                                        dF=wfactor*dF(:,1:nAtoms)*wfactor_f,       &
>                                        DwF=wfactor*DwF(:,1:nAtoms,:,:)*wfactor_f, &
>                                        dS=wfactor*dS*wfactor_s,                   &
>                                        DwS=wfactor*DwS*wfactor_s,                 &
>                                        nAtoms=nAtoms)
>            end select
431c598
<      call eval_entire_trainset(ts_trn, nTrain, nsf_max, nw_max, net, &
---
>      call eval_entire_trainset(inp%case_string, ts_trn, nNorm_trn, nsf_max, nw_max, net, &
443c610
<      call eval_entire_trainset(ts_tst, nTest, nsf_max, nw_max, net, &
---
>      call eval_entire_trainset(inp%case_string, ts_tst, nNorm_tst, nsf_max, nw_max, net, &
452,453c619,620
<         RMSE_trn = sqrt(2.0d0*SSE_trn/dble(nTrain))
<         RMSE_tst = sqrt(2.0d0*SSE_tst/dble(nTest))
---
>         RMSE_trn = sqrt(2.0d0*SSE_trn*nNorm_trn)
>         RMSE_tst = sqrt(2.0d0*SSE_tst*nNorm_tst)       
486c653
<           ts_trn, ts_tst, nTrain, nTest, nsf_max, nw_max, net)
---
>           ts_trn, ts_tst, nNorm_trn, nNorm_tst, nsf_max, nw_max, net)
624c791
<        call save_all_networks(verbose=.true.)
---
>        call save_all_networks(verbose=.true., save_ascii=inp%use_ascii)
625a793
>     call print_errors() 
632c800
<     if (allocated(ann_values)) deallocate(ann_values, ann_derivs, ann_jacobian)
---
>     if (allocated(ann_values)) deallocate(ann_values, ann_derivs, ann_derivs2, ann_jacobian)
654a823,825
>     if (allocated(DwF))     deallocate(DwF)
>     if (allocated(DwS))     deallocate(DwS)    
>     if (allocated(dF))      deallocate(dF)
719a891,894
>     double precision                                     :: struc_weight
>     double precision                                     :: volume       
>     double precision, dimension(6)                       :: strCart    
> 
722c897,899
<        call ts_read_structure_info(ts, filename, nAtoms, nTypes, E_coh)
---
>        call ts_read_structure_info(ts, filename, nAtoms, nTypes, E_coh, &
>                                    struc_weight, strCart, volume)
> 
736c913
<   subroutine eval_entire_trainset(ts, N, nsf_max, nw_max, net, &
---
>   subroutine eval_entire_trainset(case_string, ts, N, nsf_max, nw_max, net, &
743,744c920,921
<     ! N           total number of structures for normalization         !
<     !             (not necessarily equal to ts%nStrucs)                !
---
>     ! N           normalization  factor (1/N)                          !
>     !             (not necessarily equal to 1/ts%nStrucs)              !
751a929
>     character(6),                             intent(in)    :: case_string    
753c931
<     integer,                                  intent(in)    :: N
---
>     double precision,                         intent(in)    :: N
763,764c941,945
<     double precision :: dE, error
<     integer :: i
---
>     double precision                             :: dE, error
>     double precision                             :: wfactor, weight !, recnNorm
>     double precision, dimension(6)               :: dS
>     double precision, dimension(3, ts%nAtomsMax) :: dF
>     integer :: i, nAtoms
768a950,951
>     !recnNorm = 1/dble(N)
> 
770,781c953,967
<     do i = 1, ts%nStrucs
<        if (present(save_energies)) then
<           call eval_next_structure(ts, nsf_max, nw_max, net, dE, &
<                                    save_energies=save_energies)
<        else
<           call eval_next_structure(ts, nsf_max, nw_max, net, dE)
<        end if
<        error = 0.5d0*dE*dE
<        if (present(errors)) errors(i) = error
<        MAE = MAE + abs(dE)/dble(N)
<        SSE = SSE + error
<     end do
---
>     select case(case_string)
>     case("energy")
> 
>           do i = 1, ts%nStrucs
>              if (present(save_energies)) then
>                 call eval_next_structure(ts, nsf_max, nw_max, net, wfactor, &
>                                          dE=dE, save_energies=save_energies)
>              else
>                 call eval_next_structure(ts, nsf_max, nw_max, net, wfactor, dE=dE)
>              end if
>              
>              error = 0.5*wfactor*dE*dE
>              if (present(errors)) errors(i) = error
>              MAE = MAE + wfactor*abs(dE)*N
>              SSE = SSE + error
782a969,1069
>           end do
> 
>        case("forces")
>           do i = 1, ts%nStrucs            
>              call eval_next_structure(ts, nsf_max, nw_max, net, wfactor, &
>                                       dF=dF, nAtomsOut=nAtoms)
>             
>              weight = 1.0d0/(3*nAtoms)
>              error = 0.5*wfactor*sum(dF*dF)*weight
>              if (present(errors)) errors(i) = error
>              MAE = MAE + wfactor*sum(abs(dF))*weight*N
>              SSE = SSE + error
>           end do
>           
>        case("stress")
>           do i = 1, ts%nStrucs       
>              call eval_next_structure(ts, nsf_max, nw_max, net, wfactor, &
>                                       dS=dS)
>                                   
>              weight = 1.0d0/(dble(6))
>              error = 0.5*wfactor*sum(dS*dS)*weight
>              if (present(errors)) errors(i) = error
>              MAE = MAE + wfactor*sum(abs(dS))*weight*N
>              SSE = SSE + error
>           end do
>           
>        case("ElinkF")
>           do i = 1, ts%nStrucs 
>              call eval_next_structure(ts, nsf_max, nw_max, net, wfactor, &
>                                       dE=dE, dF=dF, nAtomsOut=nAtoms)
>                                   
>              error = 0.5*wfactor*dE*dE
>              if (present(errors)) errors(i) = error
>              MAE = MAE + wfactor*abs(dE)*N 
>              SSE = SSE + error
>              
>              weight = 1.0d0/(3*nAtoms)            
>              error = 0.5*wfactor*sum(dF*dF)*weight
>              if (present(errors)) errors(i) = errors(i) + error             
>              MAE = MAE + wfactor*sum(abs(dF))*weight*N
>              SSE = SSE + error             
>           end do
>           
>        case("ElinkS")
>           do i = 1, ts%nStrucs     
>              call eval_next_structure(ts, nsf_max, nw_max, net, wfactor, &
>                                       dE=dE, dS=dS)
>                                   
>              error = 0.5*wfactor*dE*dE
>              if (present(errors)) errors(i) = error
>              MAE = MAE + wfactor*abs(dE)*N
>              SSE = SSE + error
> 
>              weight = 1.0d0/(dble(6))
>              error = wfactor*sum(dS*dS)*weight
>              if (present(errors)) errors(i) = errors(i) + error              
>              MAE = MAE + wfactor*sum(abs(dS))*weight*N
>              SSE = SSE + error
>           end do
>           
>        case("FlinkS")
>           do i = 1, ts%nStrucs        
>              call eval_next_structure(ts, nsf_max, nw_max, net, wfactor, &
>                                       dF=dF, nAtomsOut=nAtoms, dS=dS)
>              
>              weight = 1.0d0/(3*nAtoms)
>              error = 0.5*wfactor*sum(dF*dF)*weight
>              if (present(errors)) errors(i) = error
>              MAE = MAE + wfactor*sum(abs(dF))*weight*N 
>              SSE = SSE + error
>              
>              weight = 1.0d0/(dble(6))
>              error = 0.5*wfactor*sum(dS*dS)*weight
>              if (present(errors)) errors(i) = errors(i) + error
>              MAE = MAE + wfactor*sum(abs(dS))*weight*N
>              SSE = SSE + error
>           end do
>           
>        case("trnAll")
>           do i = 1, ts%nStrucs
>              call eval_next_structure(ts, nsf_max, nw_max, net, wfactor, &
>                                       dE=dE, dF=dF, nAtomsOut=nAtoms, dS=dS)
> 
>              error = 0.5*wfactor*dE*dE 
>              if (present(errors)) errors(i) = error
>              MAE = MAE + wfactor*abs(dE)*N  
>              SSE = SSE + error
>              
>              weight = 1.0d0/(3*nAtoms)
>              error = 0.5*wfactor*sum(dF*dF)*weight
>              if (present(errors)) errors(i) = errors(i) + error
>              MAE = MAE + wfactor*sum(abs(dF))*weight*N
>              SSE = SSE + error
>              
>              weight = 1.0d0/(dble(6))
>              error = 0.5*wfactor*sum(dS*dS)*weight
>              if (present(errors)) errors(i) = errors(i) + error
>              MAE = MAE + wfactor*sum(abs(dS))*weight*N
>              SSE = SSE + error
>           end do          
>        end select
792,793c1079,1081
<   subroutine eval_next_structure(ts, nsf_max, nw_max, net, dE, dF, Dw, &
<                                  save_energies)
---
>   subroutine eval_next_structure(ts, nsf_max, nw_max, net, &
>                                  struc_weight, dE, dF, dS, nAtomsOut, Dw,  &
>                                  DwF, dwS, save_energies, do_pattern_weight)
807,814c1095,1112
<     type(TrnSet),                                 intent(inout) :: ts
<     integer,                                      intent(in)    :: nsf_max
<     integer,                                      intent(in)    :: nw_max
<     type(Network),    dimension(:),               intent(inout) :: net
<     double precision,                             intent(out)   :: dE
<     double precision, dimension(:,:),   optional, intent(out)   :: dF
<     double precision, dimension(:,:),   optional, intent(out)   :: Dw
<     integer,                            optional, intent(in)    :: save_energies
---
>     type(TrnSet),                                   intent(inout) :: ts
>     integer,                                        intent(in)    :: nsf_max
>     integer,                                        intent(in)    :: nw_max
>     type(Network),    dimension(:),                 intent(inout) :: net
>     
>     double precision,                               intent(out)   :: struc_weight    
>     
>     double precision,                     optional, intent(out)   :: dE
>     double precision, dimension(:,:),     optional, intent(out)   :: Dw
> 
>     double precision, dimension(:,:),     optional, intent(out)   :: dF
>     double precision, dimension(:,:,:,:), optional, intent(out)   :: DwF
>     integer,                              optional, intent(out)   :: nAtomsOut
>     double precision, dimension(:),       optional, intent(out)   :: dS    
>     double precision, dimension(:,:,:),   optional, intent(out)   :: DwS
>     
>     integer,                              optional, intent(in)    :: save_energies
>     logical,                              optional, intent(in)    :: do_pattern_weight
831,842c1129,1158
<     integer                                :: iatom, nAtoms
<     integer                                :: nTypes
<     integer                                :: itype
<     character(len=1024)                    :: filename
<     double precision                       :: E_coh
<     double precision, dimension(3)         :: forCart, cooCart
<     integer                                :: nsf, nw
<     double precision, dimension(nsf_max)   :: sfval
<     double precision                       :: E_nn, E_i
<     double precision, dimension(nsf_max)   :: F_i
<     double precision, dimension(nw_max)    :: Dw_i
<     integer,          dimension(ts%nTypes) :: natoms_type
---
>     integer                                              :: iatom, nAtoms, jatom
>     integer                                              :: nTypes
>     integer                                              :: itype
>     character(len=1024)                                  :: filename
>     double precision                                     :: E_coh
>     double precision, dimension(3)                       :: cooCart
>     double precision, dimension(3,ts%nAtomsMax)          :: forCart    
>     double precision, dimension(6)                       :: strCart    
> 
>     double precision                                     :: weight, rcpnAtoms
>     double precision                                     :: volume, vfactor
>     
>     integer                                              :: nsf, nw, iPat
>     double precision, dimension(nsf_max)                 :: sfval
>     double precision, dimension(3,nsf_max,ts%nAtomsMax)  :: sfderiv_f    
>     double precision, dimension(6,nsf_max)               :: sfderiv_s
> 
>     !double precision                                     :: repval
>     !double precision, dimension(3,ts%nAtomsMax)          :: repderiv_f    
>     !double precision, dimension(6)                       :: repderiv_s    
>     
>     double precision                                     :: E_nn, E_i
>     double precision, dimension(3, ts%nAtomsMax)         :: F_nn     
>     double precision, dimension(6)                       :: S_nn
>     
>     double precision, dimension(nsf_max)                 :: F_i
>     double precision, dimension(nw_max)                  :: Dw_i
>     double precision, dimension(3,ts%nAtomsMax,1,nw_max) :: DwF_i      
>     double precision, dimension(6, 1, nw_max)            :: DwS_i   
>     integer,          dimension(ts%nTypes)               :: natoms_type
847,848c1163,1191
<     if (present(Dw)) Dw(:,:) = 0.0d0
<     call ts_read_structure_info(ts, filename, nAtoms, nTypes, E_coh)
---
>     S_nn = 0.0d0    
>     F_nn = 0.0d0
> 
>     if (present(Dw))  Dw(:,:)      = 0.0d0
>     if (present(DwS)) DwS(:,:,:)   = 0.0d0    
>     if (present(DwF)) DwF(:,:,:,:) = 0.0d0
>     
>     if (present(dE))  dE           = 0.0d0
>     if (present(dF))  dF(:,:)      = 0.0d0    
>     if (present(dS))  dS(:)        = 0.0d0
>   
> 
>     sfval     = 0.0d0
>     sfderiv_f = 0.0d0
>     sfderiv_s = 0.0d0
>     
>     call ts_read_structure_info(ts, filename, nAtoms, nTypes, E_coh, &
>                                 struc_weight, strCart, volume)
> 
>     if (present(do_pattern_weight) .and. do_pattern_weight) then
>        do iPat = 1, inp%trn_str_psize
>           if (index(trim(filename), trim(inp%trn_str_pattern(iPat))) > 0) &
>              struc_weight = struc_weight*inp%trn_str_weights(iPat)  
>        end do   
>     end if
>     
>     rcpnAtoms = 1/dble(nAtoms)
>     vfactor   = 1/volume
>     
850c1193
<        call ts_read_atom_info(ts, itype, cooCart, forCart)
---
>        call ts_read_atom_info(ts, itype, cooCart, forCart(1:3,iatom))
852,853c1195,1259
<        call ts_read_sf_values(ts, nsf, sfval(1:nsf))
<        if (present(Dw)) then
---
>        call ts_read_sf_values(ts, nsf, nAtoms, sfval(1:nsf), & !fix
>                               sfderiv_f(1:3,1:nsf,1:nAtoms), &
>                               sfderiv_s(1:6,1:nsf)) !, repval,  &
>                               !repderiv_f(1:3,1:nAtoms), repderiv_s(1:6))
>        
>        
>        ! All the derivatives
>        if (present(Dw) .and. present(DwF) .and. present(DwS)) then
>           nw = ff_get_nweights(net(itype))
> 
>           call eval_net7(net(itype), nsf, nw, sfval(1:nsf), &
>                          sfderiv_f(1:3,1:nsf,1:nAtoms),     &
>                          sfderiv_s(1:6,1:nsf), nAtoms, E_i, &
>                          F_i(1:nsf), Dw_i(1:nw),            &
>                          DwF_i(1:3, 1:nAtoms, 1, 1:nw),     &
>                          DwS_i(1:6, 1, 1:nw))
>           
>           Dw(1:nw, itype) = Dw(1:nw, itype) - Dw_i(1:nw)*rcpnAtoms 
>           DwF(1:3, 1:nAtoms, 1:nw, itype) = DwF(1:3, 1:nAtoms, 1:nw, itype) - &         
>                                             DwF_i(1:3, 1:nAtoms, 1, 1:nw)
>           
>           DwS(1:6, 1:nw, itype) = DwS(1:6, 1:nw, itype) - DwS_i(1:6, 1, 1:nw)*vfactor 
> 
>        ! dE_dw, dF_dw, E and F - Energy and Forces training           
>        elseif (present(Dw)  .and. present(DwF)) then
>           nw = ff_get_nweights(net(itype))
> 
>           call eval_net3(net(itype), nsf, nw, sfval(1:nsf),     &
>                          sfderiv_f(1:3,1:nsf,1:nAtoms), nAtoms, &
>                          E_i, F_i(1:nsf), Dw_i(1:nw),           &
>                          DwF_i(1:3, 1:nAtoms, 1, 1:nw))
>           
>           Dw(1:nw, itype) = Dw(1:nw, itype) - Dw_i(1:nw)*rcpnAtoms
>           DwF(1:3, 1:nAtoms, 1:nw, itype) = DwF(1:3, 1:nAtoms, 1:nw, itype) - &
>                                             DwF_i(1:3, 1:nAtoms, 1, 1:nw)
>           
>        ! dE_dw, dS_dw, E and F - Energy and Stress training  
>        elseif (present(Dw)  .and. present(DwS)) then
>           nw = ff_get_nweights(net(itype))
> 
>           call eval_net4(net(itype), nsf, nw, sfval(1:nsf), &
>                          sfderiv_s(1:6,1:nsf), E_i,         &
>                          F_i(1:nsf), Dw_i(1:nw),            &
>                          DwS_i(1:6, 1, 1:nw))
>           
>           Dw(1:nw, itype) = Dw(1:nw, itype) - Dw_i(1:nw)*rcpnAtoms
>           DwS(1:6, 1:nw, itype) = DwS(1:6, 1:nw, itype) - DwS_i(1:6, 1, 1:nw)*vfactor       
> 
>        ! dF_dw, dS_dw,  and F - Forces and Stress training  
>        elseif (present(DwF) .and. present(DwS)) then
>           nw = ff_get_nweights(net(itype))
> 
>           call eval_net8(net(itype), nsf, nw, sfval(1:nsf), &
>                          sfderiv_f(1:3,1:nsf,1:nAtoms),     &
>                          sfderiv_s(1:6,1:nsf), nAtoms, E_i, &
>                          F_i(1:nsf),                        &
>                          DwF_i(1:3, 1:nAtoms, 1, 1:nw),     &
>                          DwS_i(1:6, 1, 1:nw))
>           
>           DwF(1:3, 1:nAtoms, 1:nw, itype) = DwF(1:3, 1:nAtoms, 1:nw, itype) - &
>                                             DwF_i(1:3, 1:nAtoms, 1, 1:nw)
>           DwS(1:6, 1:nw, itype) = DwS(1:6, 1:nw, itype) - DwS_i(1:6, 1, 1:nw)*vfactor 
>        
>        ! dE_dw and E - energy training        
>        elseif (present(Dw)) then
857c1263,1281
<           Dw(1:nw, itype) = Dw(1:nw, itype) - Dw_i(1:nw)/dble(nAtoms)
---
>           Dw(1:nw, itype) = Dw(1:nw, itype) - Dw_i(1:nw)*rcpnAtoms
>           
>        ! dF_dw and F - Forces trainin
>        elseif (present(DwF)) then
>           nw = ff_get_nweights(net(itype))
>           call eval_net5(net(itype), nsf, nw, sfval(1:nsf), E_i,    &
>                          F_i(1:nsf), sfderiv_f(1:3,1:nsf,1:nAtoms), &
>                          nAtoms, DwF_i(1:3, 1:nAtoms, 1, 1:nw))  
>           DwF(1:3, 1:nAtoms, 1:nw, itype) = DwF(1:3, 1:nAtoms, 1:nw, itype) - &
>                                             DwF_i(1:3, 1:nAtoms, 1, 1:nw)
> 
>        ! dS_dw and F - Stress training
>        elseif (present(DwS)) then
>           nw = ff_get_nweights(net(itype))
>           call eval_net6(net(itype), nsf, nw, sfval(1:nsf), E_i, &
>                          F_i(1:nsf), sfderiv_s(1:6,1:nsf),       &
>                          DwS_i(1:6, 1, 1:nw))         
>           DwS(1:6, 1:nw, itype) = DwS(1:6, 1:nw, itype) - DwS_i(1:6, 1, 1:nw)*vfactor
>           
861c1285,1294
<        E_nn = E_nn + E_i
---
>        
>        
>        E_nn                = E_nn + E_i
>        do jatom = 1, nAtoms    
>           F_nn(1:3, jatom) = F_nn(1:3, jatom) + &
>                              matmul(sfderiv_f(1:3,1:nsf,jatom), F_i(1:nsf))
>        end do
>        S_nn(1:6)           = S_nn(1:6) + matmul(sfderiv_s(1:6,1:nsf), F_i(1:nsf))       
> 
>        
865c1298,1307
<     dE = (E_coh - E_nn)/dble(nAtoms)
---
>     if (present(dE)) dE = (E_coh - E_nn)*rcpnAtoms
>     if (present(dS)) dS = (strCart(1:6) - S_nn(1:6)*vfactor)
>     !if (present(dS)) then
>     !   write(*,*) "PBE", strCart
>     !   write(*,*) "ANN", S_nn*vfactor
>     !   write(*,*) "DIF", dS       
>     !end if   
>     if (present(dF)) then
>        dF(1:3,1:nAtoms) = (-forCart(1:3,1:nAtoms) - F_nn(1:3,1:nAtoms))
>     end if
872,873c1314,1315
<             advance='no') E_coh, E_nn, nAtoms, E_coh/dble(nAtoms), &
<             E_nn/dble(nAtoms), dE/ts%scale, dE
---
>             advance='no') E_coh, E_nn, nAtoms, E_coh*rcpnAtoms, &
>             E_nn*rcpnAtoms, dE/ts%scale, dE
880c1322,1323
<     if (present(dF)) dF(:,:) = 0.0d0
---
> 
>     if (present(nAtomsOut)) nAtomsOut = nAtoms 
900,902c1343,1345
<     ann_values(:) = 0.0d0
<     ann_derivs(:) = 0.0d0
<     ann_jacobian(:) = 0.0d0
---
>     ann_values(:)    = 0.0d0
>     ann_derivs(:)    = 0.0d0
>     ann_jacobian(:)  = 0.0d0
933a1377,1689
>   subroutine eval_net3(net, nsf, nw, sfval, sfderiv, na, E, F, Dw, DwF)
> 
>     implicit none
> 
>     type(Network),                             intent(inout) :: net
>     integer,                                   intent(in)    :: nsf
>     integer,                                   intent(in)    :: nw
>     double precision, dimension(nsf),          intent(in)    :: sfval
>     double precision,                          intent(out)   :: E
>     double precision, dimension(nsf),          intent(out)   :: F
>     double precision, dimension(nw),           intent(out)   :: Dw
>     integer,                                   intent(in)    :: na
>     double precision, dimension(3, nsf, na),   intent(in)    :: sfderiv
>     double precision, dimension(3, na, 1, nw), intent(out)   :: DwF  
> 
>     double precision, dimension(1) :: Ebuff
> 
>     ann_values(:)    = 0.0d0
>     ann_derivs(:)    = 0.0d0
>     ann_derivs2(:)   = 0.0d0
>     ann_jacobian(:)  = 0.0d0
>     call ff_eval(net, nsf, sfval(1:nsf), 1, ann_values, ann_derivs, &
>                  Ebuff, derivs2=ann_derivs2)
>     call ff_deriv(net, nsf, 1, ann_derivs, ann_jacobian, F(1:nsf))
>     call ff_wderiv(net, nw, 1, ann_values, ann_derivs, ann_jacobian, Dw)
>     call ff_fwderiv(net, nw, nsf, 1, na, sfderiv(1:3, 1:nsf, 1:na),   &
>                     ann_values, ann_derivs, ann_derivs2, ann_jacobian, &
>                     DwF(1:3, 1:na, 1:1, 1:nw))
> 
>     E = Ebuff(1)
> 
>   end subroutine eval_net3
> 
>   subroutine eval_net4(net, nsf, nw, sfval, sfderiv_s, E, F, Dw, DwS)
> 
>     implicit none
> 
>     type(Network),                         intent(inout) :: net
>     integer,                               intent(in)    :: nsf
>     integer,                               intent(in)    :: nw
>     double precision, dimension(nsf),      intent(in)    :: sfval
>     double precision,                      intent(out)   :: E
>     double precision, dimension(nsf),      intent(out)   :: F
>     double precision, dimension(nw),       intent(out)   :: Dw
>     double precision, dimension(6,nsf),    intent(in)    :: sfderiv_s
>     double precision, dimension(6, 1, nw), intent(out)   :: DwS  
> 
>     double precision, dimension(1) :: Ebuff
> 
>     ann_values(:)    = 0.0d0
>     ann_derivs(:)    = 0.0d0
>     ann_derivs2(:)   = 0.0d0
>     ann_jacobian(:)  = 0.0d0
>     call ff_eval(net, nsf, sfval(1:nsf), 1, ann_values, ann_derivs, &
>                  Ebuff, derivs2=ann_derivs2)
>     call ff_deriv(net, nsf, 1, ann_derivs, ann_jacobian, F(1:nsf))
>     call ff_wderiv(net, nw, 1, ann_values, ann_derivs, ann_jacobian, Dw)
>     call ff_swderiv(net, nw, nsf, 1, sfderiv_s(1:6, 1:nsf),           &
>                     ann_values, ann_derivs, ann_derivs2, ann_jacobian, &
>                     DwS(1:6, 1:1, 1:nw))
> 
>     E = Ebuff(1)
> 
>   end subroutine eval_net4
> 
>   subroutine eval_net5(net, nsf, nw, sfval, E, F, sfderiv, na,  DwF)
> 
>     implicit none
> 
>     type(Network),                             intent(inout) :: net
>     integer,                                   intent(in)    :: nsf
>     integer,                                   intent(in)    :: nw
>     double precision, dimension(nsf),          intent(in)    :: sfval
>     double precision,                          intent(out)   :: E    
>     double precision, dimension(nsf),          intent(out)   :: F
>     integer,                                   intent(in)    :: na
>     double precision, dimension(3, nsf, na),   intent(in)    :: sfderiv
>     double precision, dimension(3, na, 1, nw), intent(out)   :: DwF  
> 
>     double precision, dimension(1) :: Ebuff
>     
>     ann_values(:)    = 0.0d0
>     ann_derivs(:)    = 0.0d0
>     ann_derivs2(:)   = 0.0d0
>     ann_jacobian(:)  = 0.0d0
> 
>     call ff_eval(net, nsf, sfval(1:nsf), 1, ann_values, ann_derivs, &
>                  Ebuff, derivs2=ann_derivs2)
>     call ff_deriv(net, nsf, 1, ann_derivs, ann_jacobian, F(1:nsf))
>     call ff_fwderiv(net, nw, nsf, 1, na, sfderiv(1:3, 1:nsf, 1:nAtoms),   &
>                     ann_values, ann_derivs, ann_derivs2, ann_jacobian, &
>                     DwF(1:3, 1:na, 1:1, 1:nw))
> 
>     E = Ebuff(1)
>     
>   end subroutine eval_net5
> 
>   subroutine eval_net6(net, nsf, nw, sfval, E, F, sfderiv_s, DwS)
> 
>     implicit none
> 
>     type(Network),                             intent(inout) :: net
>     integer,                                   intent(in)    :: nsf
>     integer,                                   intent(in)    :: nw
>     double precision, dimension(nsf),          intent(in)    :: sfval
>     double precision,                          intent(out)   :: E    
>     double precision, dimension(nsf),          intent(out)   :: F
>     double precision, dimension(6, nsf),       intent(in)    :: sfderiv_s
>     double precision, dimension(6, 1, nw),     intent(out)   :: DwS  
> 
>     double precision, dimension(1) :: Ebuff
> 
>     ann_values(:)    = 0.0d0
>     ann_derivs(:)    = 0.0d0
>     ann_derivs2(:)   = 0.0d0
>     ann_jacobian(:)  = 0.0d0
>     call ff_eval(net, nsf, sfval(1:nsf), 1, ann_values, ann_derivs, &
>                  Ebuff, derivs2=ann_derivs2)
>     call ff_deriv(net, nsf, 1, ann_derivs, ann_jacobian, F(1:nsf))
>     call ff_swderiv(net, nw, nsf, 1, sfderiv_s(1:6, 1:nsf),           &
>                     ann_values, ann_derivs, ann_derivs2, ann_jacobian, &
>                     DwS(1:6, 1:1, 1:nw))
>     
>     E = Ebuff(1)
> 
>   end subroutine eval_net6
> 
>   subroutine eval_net7(net, nsf, nw, sfval, sfderiv, sfderiv_s, &
>                        na, E, F, Dw, DwF, DwS)
> 
>     implicit none
> 
>     type(Network),                             intent(inout) :: net
>     integer,                                   intent(in)    :: nsf
>     integer,                                   intent(in)    :: nw
>     double precision, dimension(nsf),          intent(in)    :: sfval
>     double precision, dimension(3, nsf, na),   intent(in)    :: sfderiv
>     double precision, dimension(6, nsf),       intent(in)    :: sfderiv_s
> 
>     integer,                                   intent(in)    :: na   
>     double precision,                          intent(out)   :: E
>     double precision, dimension(nsf),          intent(out)   :: F
> 
>     double precision, dimension(nw),           intent(out)   :: Dw
>     double precision, dimension(3, na, 1, nw), intent(out)   :: DwF
>     double precision, dimension(6, 1, nw),     intent(out)   :: DwS
> 
>     double precision, dimension(1) :: Ebuff
> 
>     ann_values(:)    = 0.0d0
>     ann_derivs(:)    = 0.0d0
>     ann_derivs2(:)   = 0.0d0
>     ann_jacobian(:)  = 0.0d0    
>     call ff_eval(net, nsf, sfval(1:nsf), 1, ann_values, ann_derivs, &
>                  Ebuff, derivs2=ann_derivs2)
>     call ff_deriv(net, nsf, 1, ann_derivs, ann_jacobian, F(1:nsf))
>     call ff_wderiv(net, nw, 1, ann_values, ann_derivs, ann_jacobian, Dw)
>     call ff_fwderiv(net, nw, nsf, 1, na, sfderiv(1:3, 1:nsf, 1:na),   &
>                     ann_values, ann_derivs, ann_derivs2, ann_jacobian, &
>                     DwF(1:3, 1:na, 1:1, 1:nw))
>     call ff_swderiv(net, nw, nsf, 1, sfderiv_s(1:6, 1:nsf),           &
>                     ann_values, ann_derivs, ann_derivs2, ann_jacobian, &
>                     DwS(1:6, 1:1, 1:nw))
> 
>     E = Ebuff(1)
> 
>   end subroutine eval_net7
> 
>   subroutine eval_net8(net, nsf, nw, sfval, sfderiv, sfderiv_s, &
>                        na, E, F, DwF, DwS)
> 
>     implicit none
> 
>     type(Network),                             intent(inout) :: net
>     integer,                                   intent(in)    :: nsf
>     integer,                                   intent(in)    :: nw
>     double precision, dimension(nsf),          intent(in)    :: sfval
>     double precision, dimension(3, nsf, na),   intent(in)    :: sfderiv
>     double precision, dimension(6, nsf),       intent(in)    :: sfderiv_s
> 
>     integer,                                   intent(in)    :: na   
>     double precision,                          intent(out)   :: E
>     double precision, dimension(nsf),          intent(out)   :: F
> 
>     double precision, dimension(3, na, 1, nw), intent(out)   :: DwF
>     double precision, dimension(6, 1, nw),     intent(out)   :: DwS
> 
>     double precision, dimension(1) :: Ebuff
> 
>     ann_values(:)    = 0.0d0
>     ann_derivs(:)    = 0.0d0
>     ann_derivs2(:)   = 0.0d0
>     ann_jacobian(:)  = 0.0d0    
>     call ff_eval(net, nsf, sfval(1:nsf), 1, ann_values, ann_derivs, &
>                  Ebuff, derivs2=ann_derivs2)
>     call ff_deriv(net, nsf, 1, ann_derivs, ann_jacobian, F(1:nsf))
>     call ff_fwderiv(net, nw, nsf, 1, na, sfderiv(1:3, 1:nsf, 1:na),   &
>                     ann_values, ann_derivs, ann_derivs2, ann_jacobian, &
>                     DwF(1:3, 1:na, 1:1, 1:nw))
>     call ff_swderiv(net, nw, nsf, 1, sfderiv_s(1:6, 1:nsf),           &
>                     ann_values, ann_derivs, ann_derivs2, ann_jacobian, &
>                     DwS(1:6, 1:1, 1:nw))
> 
>     E = Ebuff(1)
> 
>   end subroutine eval_net8  
> 
>   subroutine gradient_check_f(net, nsf, nw, sfval, natoms, sfderiv,  DwF, F_total)
> 
>     implicit none
> 
>     type(Network),                             intent(inout) :: net
>     integer,                                   intent(in)    :: nsf
>     integer,                                   intent(in)    :: nw
>     double precision, dimension(nsf),          intent(in)    :: sfval
>     integer,                                   intent(in)    :: natoms
>     double precision, dimension(3,nsf,natoms), intent(in)    :: sfderiv
>     double precision, dimension(3,natoms,nw),  intent(in)    :: DwF
>     double precision, dimension(3,natoms,nw),  intent(out)   :: F_total 
> 
>     double precision, dimension(1)     :: Ebuff
>     double precision, dimension(nw)    :: netWsave
>     double precision, dimension(nsf)   :: Fbuff_p, Fbuff_m
>     double precision, dimension(3, natoms) :: F_nn_p, F_nn_m, dF_diw
>     double precision :: epsilon
>     integer :: iw, jw, jatom
>        
>     netWsave(1:nw) = net%W(1:nw)
>     epsilon = 1.0d-9
>     write(*,*) epsilon
>     do iw = 1, nw
>        net%W(1:nw) = netWsave(1:nw)
>        net%W(iw) = net%W(iw) + epsilon
>        ann_values(:)    = 0.0d0
>        ann_derivs(:)    = 0.0d0
>        ann_jacobian(:)  = 0.0d0       
>        call ff_eval(net, nsf, sfval(1:nsf), 1, ann_values, ann_derivs, Ebuff)
>        call ff_deriv(net, nsf, 1, ann_derivs, ann_jacobian, Fbuff_p(1:nsf))       
> 
> 
>        net%W(iw) = net%W(iw) - 2*epsilon
>        ann_values(:)    = 0.0d0
>        ann_derivs(:)    = 0.0d0
>        ann_jacobian(:)  = 0.0d0       
>        call ff_eval(net, nsf, sfval(1:nsf), 1, ann_values, ann_derivs, Ebuff)
>        call ff_deriv(net, nsf, 1, ann_derivs, ann_jacobian, Fbuff_m(1:nsf))         
>        
>        do jatom = 1, natoms
>           F_nn_p(1:3, jatom) = matmul(sfderiv(1:3,1:nsf,jatom), Fbuff_p(1:nsf))
>           F_nn_m(1:3, jatom) = matmul(sfderiv(1:3,1:nsf,jatom), Fbuff_m(1:nsf))
>        end do
> 
>        dF_diw(1:3, 1:natoms) =  (F_nn_p(1:3, 1:natoms) - F_nn_m(1:3, 1:natoms))/(2*epsilon)
>        F_total(1:3, 1:natoms, iw) = dF_diw(1:3, 1:natoms)
>        do jatom = 1, natoms
>           write(*,*) iw, jatom, dF_diw(1:3, jatom) - DwF(1:3, jatom, iw)
>        end do   
>     end do
> 
>   end subroutine gradient_check_f
> 
>   subroutine gradient_check_s(net, nsf, nw, sfval, natoms, sfderiv_s,  DwS, S_total)
> 
>     implicit none
> 
>     type(Network),                             intent(inout) :: net
>     integer,                                   intent(in)    :: nsf
>     integer,                                   intent(in)    :: nw
>     double precision, dimension(nsf),          intent(in)    :: sfval
>     integer,                                   intent(in)    :: natoms
>     double precision, dimension(6,nsf),        intent(in)    :: sfderiv_s
>     double precision, dimension(6,nw),         intent(in)    :: DwS
>     double precision, dimension(6,nw),         intent(out)   :: S_total 
> 
>     double precision, dimension(1)     :: Ebuff
>     double precision, dimension(nw)    :: netWsave
>     double precision, dimension(nsf)   :: Fbuff_p, Fbuff_m
>     double precision, dimension(6) :: S_nn_p, S_nn_m, dS_diw
>     double precision :: epsilon
>     integer :: iw, jw, jatom
>        
>     netWsave(1:nw) = net%W(1:nw)
>     epsilon = 1.0d-9
>     write(*,*) epsilon
>     do iw = 1, nw
>        net%W(1:nw) = netWsave(1:nw)
>        net%W(iw) = net%W(iw) + epsilon
>        ann_values(:)    = 0.0d0
>        ann_derivs(:)    = 0.0d0
>        ann_jacobian(:)  = 0.0d0
>        call ff_eval(net, nsf, sfval(1:nsf), 1, ann_values, ann_derivs, Ebuff)
>        call ff_deriv(net, nsf, 1, ann_derivs, ann_jacobian, Fbuff_p(1:nsf))
>        
>        ann_values(:)    = 0.0d0
>        ann_derivs(:)    = 0.0d0
>        ann_jacobian(:)  = 0.0d0
>        net%W(iw) = net%W(iw) - 2*epsilon
>        call ff_eval(net, nsf, sfval(1:nsf), 1, ann_values, ann_derivs, Ebuff)
>        call ff_deriv(net, nsf, 1, ann_derivs, ann_jacobian, Fbuff_m(1:nsf))       
>        
>        do jatom = 1, 6
>           S_nn_p(1:6) = matmul(sfderiv_s(1:6,1:nsf), Fbuff_p(1:nsf))
>           S_nn_m(1:6) = matmul(sfderiv_s(1:6,1:nsf), Fbuff_m(1:nsf))
>        end do
> 
>        dS_diw(1:6) =  (S_nn_p(1:6) - S_nn_m(1:6))/(2*epsilon)
>        S_total(1:6, iw) = dS_diw(1:6)
>        write(*,*) iw, dS_diw(1:6) - DwS(1:6, iw)
>  
>     end do
> 
>   end subroutine gradient_check_s  
> 
995c1751
<     integer                                 :: nsf
---
>     integer                                 :: nsf, isf, icoo
1003a1760,1768
>     double precision                                     :: struc_weight
>     double precision                                     :: volume       
>     double precision, dimension(6)                       :: strCart
>     double precision, dimension(3,nsf_max,ts%nAtomsMax)  :: sfderiv_f
>     double precision, dimension(6,nsf_max)               :: sfderiv_s
>     !double precision                                     :: repval  
>     !double precision, dimension(3,ts%nAtomsMax)          :: repderiv_f   
>     !double precision, dimension(6)                       :: repderiv_s        
> 
1051c1816
< 
---
>  
1053c1818,1819
<           call ts_read_structure_info(ts, filename, natoms, ntypes, energy)
---
>           call ts_read_structure_info(ts, filename, natoms, ntypes, energy, &
>                                       struc_weight, strCart, volume)
1055c1821,1822
<              call ts_write_structure_info(ts_p, filename, natoms, ntypes, energy)
---
>              call ts_write_structure_info(ts_p, filename, natoms, ntypes, energy, &
>                                           struc_weight, strCart, volume)
1060a1828,1831
>              
>              call pp_send(struc_weight, dest=iproc)
>              call pp_send(strCart, 6,   dest=iproc)             
>              call pp_send(volume,       dest=iproc)              
1073c1844,1848
<              call ts_read_sf_values(ts, nsf, sfval(1:nsf))
---
>              call ts_read_sf_values(ts, nsf, nAtoms, sfval(1:nsf), &
>                                     sfderiv_f(1:3,1:nsf,1:natoms), &
>                                     sfderiv_s(1:6,1:nsf)) !, repval,  &
>                                     !repderiv_f(1:3,1:natoms),      &
>                                     !repderiv_s(1:6))
1075c1850,1854
<                 call ts_write_sf_info(ts_p, nsf, sfval(1:nsf))
---
>                 call ts_write_sf_info(ts_p, nsf, nAtoms, sfval(1:nsf), &
>                                       sfderiv_f(1:3,1:nsf,1:natoms),   &
>                                       sfderiv_s(1:6,1:nsf))!, repval,    &
>                                       !repderiv_f(1:3,1:natoms),        &
>                                       !repderiv_s(1:6))
1081,1083c1860,1872
<                 !$$ do isf = 1, nsf
<                 !$$    call pp_send(sfderiv(1:3,isf), 3, dest=iproc)
<                 !$$ end do
---
>                 do icoo = 1, 3
>                    do isf = 1, nsf
>                       call pp_send(sfderiv_f(icoo,isf,1:natoms), natoms, dest=iproc)
>                    end do
>                 end do
>                 do isf = 1, nsf
>                    call pp_send(sfderiv_s(1:6,isf), 6, dest=iproc)
>                 end do
>                 !call pp_send(repval, dest=iproc)
>                 !do icoo = 1,3
>                 !   call pp_send(repderiv_f(icoo, 1:nAtoms), nAtoms, dest=iproc)
>                 !end do   
>                 !call pp_send(repderiv_s(1:6), 6, dest=iproc)
1097c1886,1893
<           call ts_write_structure_info(ts_p, filename, natoms, ntypes, energy)
---
>           
>           call pp_recv(struc_weight)
>           call pp_recv(strCart, 6)          
>           call pp_recv(volume)
>          
>           call ts_write_structure_info(ts_p, filename, natoms, ntypes, energy, &
>                                        struc_weight, strCart, volume)
> 
1105,1108c1901,1920
<              !$$ do isf = 1, nsf
<              !$$    call pp_recv(sfderiv(1:3,isf), 3)
<              !$$ end do
<              call ts_write_sf_info(ts_p, nsf, sfval(1:nsf))
---
>              do icoo = 1, 3
>                 do isf = 1, nsf
>                    call pp_recv(sfderiv_f(icoo,isf,1:natoms), natoms)
>                 end do
>              end do
>              do isf = 1, nsf
>                 call pp_recv(sfderiv_s(1:6,isf), 6)
>              end do
>              !call pp_recv(repval)
>              !do icoo = 1, 3              
>              !   call pp_recv(repderiv_f(icoo,1:natoms), natoms)
>              !end do
>              !call pp_recv(repderiv_s(1:6), 6)
>              
>              call ts_write_sf_info(ts_p, nsf, natoms, sfval(1:nsf), &
>                                    sfderiv_f(1:3,1:nsf,1:natoms),   &
>                                    sfderiv_s(1:6,1:nsf))!, repval,    &
>                                    !repderiv_f(1:3,1:natoms),        &
>                                    !repderiv_s(1:6))
>              
1145c1957
<     integer :: ifile, itest
---
>     integer :: ifile, itest, ipattern
1172a1985,1996
>     write(*,*) 'Objectives weights      : '
>     write(*,*) '  alpha                 : ', trim(io_adjustl(inp%trn_w_obj(1)))
>     write(*,*) '  beta                  : ', trim(io_adjustl(inp%trn_w_obj(2)))
>     write(*,*) '  gamma                 : ', trim(io_adjustl(inp%trn_w_obj(3)))    
>     write(*,*)
> 
>     write(*,*) 'Pattern weights         : '
>     do ipattern = 1, inp%trn_str_psize
>        write(*,'(A2,A22,A3,A7)') "   ", inp%trn_str_pattern(ipattern), " : ", &
>                   trim(io_adjustl(inp%trn_str_weights(ipattern)))
>     end do   
>     write(*,*)        
1198c2022
<   subroutine print_training_header(nIters, method)
---
>   subroutine print_training_header(nIters, method, case_string)
1203a2028
>     character(6),     intent(in) :: case_string    
1205c2030,2046
<     call aeio_header("Training process")
---
>     write(*,*)
>     select case(case_string)
>        case("energy")
>           call aeio_header("Training process: energy")
>        case("forces")
>           call aeio_header("Training process: forces")
>        case("stress")
>           call aeio_header("Training process: stress")
>        case("ElinkF")
>           call aeio_header("Training process: energy | forces")
>        case("ElinkS")
>           call aeio_header("Training process: energy | stress ")
>        case("FlinkS")
>           call aeio_header("Training process: forces | stress ")          
>        case("trnAll")
>           call aeio_header("Training process: energy | forces | stress")
>     end select
1244c2085
<   subroutine save_all_networks(verbose, iter)
---
>   subroutine save_all_networks(verbose, iter, save_ascii)
1249a2091
>     logical, optional, intent(in) :: save_ascii    
1280a2123,2133
>        if (present(save_ascii) .and. save_ascii) then     !(when inp option and input for function)
>           if (present(verbose)) then
>              write(*,*) 'Saving the ', trim(ts%typeName(itype)), &
>                ' network to file : ', trim(inp%netFile(itype)) // trim(".ascii") // trim(enum) 
>           end if
>           open(u_sav, file=trim(inp%netFile(itype))//trim(".ascii")//trim(enum), action='write')
>           call save_Network_ASCII(net(itype), unit=u_sav)
>           call save_Setup_ASCII(stp(itype), unit=u_sav)
>           call save_TrnSet_info_ASCII(ts, unit=u_sav)
>           close(u_sav)
>        end if
1297,1298c2150,2151
<     integer,                     intent(in)    :: nTrain
<     integer,                     intent(in)    :: nTest
---
>     double precision,            intent(in)    :: nTrain !normalization (1/NormTrain)
>     double precision,            intent(in)    :: nTest  !normalization (1/NormTest)
1337c2190
<     call eval_entire_trainset(ts_trn, nTrain, nsf_max, nw_max, net, &
---
>     call eval_entire_trainset("energy", ts_trn, nTrain, nsf_max, nw_max, net, &
1345c2198
<     call eval_entire_trainset(ts_tst, nTest, nsf_max, nw_max, net, &
---
>     call eval_entire_trainset("energy", ts_tst, nTest, nsf_max, nw_max, net, &
1351c2204
<        RMSE_trn = 1000.0d0*sqrt(2.0d0*SSE_trn/dble(nTrain))/ts_trn%scale
---
>        RMSE_trn = 1000.0d0*sqrt(2.0d0*SSE_trn*nTrain)/ts_trn%scale
1353c2206
<        RMSE_tst = 1000.0d0*sqrt(2.0d0*SSE_tst/dble(nTest))/ts_tst%scale
---
>        RMSE_tst = 1000.0d0*sqrt(2.0d0*SSE_tst*nTest)/ts_tst%scale
1483a2337,2368
> 
>   subroutine print_errors()
>     implicit none
> 
>     double precision, dimension(6) :: errors
> 
>     call eval_entire_trainset("energy", ts_trn, nNorm_trn, nsf_max, nw_max, net, &
>                               errors(1), errors(2))
>     call eval_entire_trainset("forces", ts_trn, nNorm_trn, nsf_max, nw_max, net, &
>                               errors(3), errors(4))
>     call eval_entire_trainset("stress", ts_trn, nNorm_trn, nsf_max, nw_max, net, &
>                               errors(5), errors(6))
> 
> 
>     !if (ppSize > 1) then
>     !   call pp_sum(errors(1:6), 6)
>     !end if
> 
>     if (ppMaster) then
> 
>        write(*,*)
>        write(*,*) "Training set errors: "
>        write(*,*)
>        write(*,'(4x,A20,2x,ES14.6,2x,ES14.6)')  "Errors energy", &
>             errors(1)/ts_trn%scale,  sqrt(2.0d0*errors(2)*nNorm_trn)/ts_trn%scale
>        write(*,'(4x,A20,2x,ES14.6,2x,ES14.6)')  "Errors forces", &
>             errors(3)/ts_trn%scale,  sqrt(2.0d0*errors(4)*nNorm_trn)/ts_trn%scale
>        write(*,'(4x,A20,2x,ES14.6,2x,ES14.6)')  "Errors stress", &
>             errors(5)/ts_trn%scale,  sqrt(2.0d0*errors(6)*nNorm_trn)/ts_trn%scale 
>     end if
>     
>   end subroutine print_errors  
diff -r aenet-2.0.3/src/trainset.f90 aenet-x2.0.3/src/trainset.f90
119a120,122
>      double precision                                  :: normalization
>      integer                                           :: nAtomsMax  
> 
175a179,181
>     ts%nAtomsMax     = 0
>     ts%normalization = 0    
> 
200a207
>     
210c217
<     
---
> 
350a358,359
>     write(u) ts%nAtomsMax
>     write(u) ts%normalization    
394a404,405
>     write(u,*) ts%nAtomsMax
>     write(u,*) ts%normalization    
434a446,447
>     read(u) ts%nAtomsMax
>     read(u) ts%normalization    
479a493,494
>     read(u,*) ts%nAtomsMax
>     read(u,*) ts%normalization    
502,510c517,527
<     ts%nTypes     = nTypes
<     ts%normalized = .false.
<     ts%scale      = 1.0d0
<     ts%shift      = 1.0d0
<     ts%file       = ''
<     ts%unit       = -1
<     ts%nAtomsTot  = 0
<     ts%nStrucs    = 0
<     ts%iStruc     = 0
---
>     ts%nTypes        = nTypes
>     ts%normalized    = .false.
>     ts%scale         = 1.0d0
>     ts%shift         = 1.0d0
>     ts%file          = ''
>     ts%unit          = -1
>     ts%nAtomsTot     = 0
>     ts%nAtomsMax     = 0 
>     ts%normalization = 0     
>     ts%nStrucs       = 0
>     ts%iStruc        = 0
530c547
<     integer                                     :: iatom, nAtoms
---
>     integer                                     :: iatom, nAtoms, nAtomsMax
533a551
>     double precision                            :: Struc_weight, volume     
534a553
>     double precision, dimension(6)              :: strCart     
536c555,562
<     double precision, dimension(:), allocatable :: sfval
---
>     
>     double precision, dimension(:),     allocatable :: sfval
>     double precision, dimension(:,:,:), allocatable :: sfderiv_f
>     double precision, dimension(:,:),   allocatable :: sfderiv_s
> 
>     double precision                                :: repval
>     double precision, dimension(:,:),  allocatable  :: repderiv_f
>     double precision, dimension(6)                  :: repderiv_s    
559,560c585,588
<     nsf_max = 100
<     allocate(sfval(nsf_max))
---
>     nsf_max   = 100
>     nAtomsMax = ts%nAtomsMax    
>     allocate(sfval(nsf_max), sfderiv_f(3,nsf_max,nAtomsMax), &
>              sfderiv_s(6,nsf_max), repderiv_f(3,nAtomsMax))
563c591,592
<        call ts_read_structure_info(ts, filename, nAtoms, nTypes, E_coh)
---
>        call ts_read_structure_info(ts, filename, nAtoms, nTypes, E_coh, &
>                                    Struc_weight, strCart, volume)
576,577c605,607
<              deallocate(sfval)
<              allocate(sfval(nsf_max))
---
>              deallocate(sfval, sfderiv_f, sfderiv_s)
>              allocate(sfval(nsf_max), sfderiv_f(3,nsf_max,nAtomsMax), &
>                       sfderiv_s(6,nsf_max))
579c609,616
<           call ts_read_sf_values(ts, nsf, sfval(1:nsf))
---
>           if (nAtoms > nAtomsMax) then
>              nAtomsMax = nAtoms
>              deallocate(sfderiv_f, repderiv_f)
>              allocate(sfderiv_f(3,nsf_max,nAtomsMax), repderiv_f(3,nAtomsMax))
>           end if          
>           call ts_read_sf_values(ts, nsf, nAtoms, sfval(1:nsf),                       &
>                                  sfderiv_f(1:3,1:nsf,1:nAtoms), sfderiv_s(1:6,1:nsf))!, &
>                                  !repval, repderiv_f(1:3,1:nAtoms), repderiv_s(1:6))
585c622
<     deallocate(sfval)
---
>     deallocate(sfval, sfderiv_f, sfderiv_s, repderiv_f)
608c645
<     integer                                     :: iatom, nAtoms
---
>     integer                                     :: iatom, nAtoms, nAtomsMax
611a649
>     double precision                            :: Struc_weight, volume      
612a651
>     double precision, dimension(6)              :: strCart     
614c653,660
<     double precision, dimension(:), allocatable :: sfval
---
> 
>     double precision, dimension(:),     allocatable :: sfval
>     double precision, dimension(:,:,:), allocatable :: sfderiv_f
>     double precision, dimension(:,:),   allocatable :: sfderiv_s
> 
>     double precision                                :: repval
>     double precision, dimension(:,:),   allocatable :: repderiv_f
>     double precision, dimension(6)                  :: repderiv_s      
640a687
>     nAtomsMax = ts1%nAtomsMax
643,644c690,693
<     nsf_max = 100
<     allocate(sfval(nsf_max))
---
>     nsf_max   = 100
>     nAtomsMax = 100    
>     allocate(sfval(nsf_max), sfderiv_f(3,nsf_max,nAtomsMax), &
>              sfderiv_s(6,nsf_max), repderiv_f(3,nAtomsMax)) 
650c699,700
<        call ts_write_structure_info(ts, filename, nAtoms, nTypes, energy)
---
>        call ts_write_structure_info(ts, filename, nAtoms, nTypes, energy, &
>                                     Struc_weight, strCart, volume)
660a711,718
>              deallocate(sfval, sfderiv_f, sfderiv_s)
>              allocate(sfval(nsf_max), sfderiv_f(3,nsf_max,nAtomsMax), &
>                       sfderiv_s(6,nsf_max))
>           end if
>           if (nAtoms > nAtomsMax) then
>              nAtomsMax = nAtoms
>              deallocate(sfderiv_f, repderiv_f)
>              allocate(sfderiv_f(3,nsf_max,nAtomsMax), repderiv_f(3,nAtomsMax))
663c721,723
<           call ts_write_sf_info(ts, nsf, sfval(1:nsf))
---
>           call ts_write_sf_info(ts, nsf, nAtoms, sfval(1:nsf), &
>                sfderiv_f(1:3,1:nsf,1:nAtoms), sfderiv_s(1:6,1:nsf))!,   &
>                !repval, repderiv_f(1:3,1:nAtoms), repderiv_s(1:6))
667c727
<     deallocate(sfval)
---
>     deallocate(sfval, sfderiv_f, sfderiv_s, repderiv_f)
747a808
>    
793a855
>     
814c876,877
<     read(ts%unit) ! ts%shift
---
>     read(ts%unit) ! ts%shift   
>     
839a903,904
>     write(ts%unit) ts%nAtomsMax
>     write(ts%unit) ts%normalization     
879a945,946
>     read(ts%unit) ts%nAtomsMax
>     read(ts%unit) ts%normalization    
904c971,972
<   subroutine ts_write_structure_info(ts, filename, nAtoms, nTypes, energy)
---
>   subroutine ts_write_structure_info(ts, filename, nAtoms, nTypes, energy, &
>                                      Struc_weight, strCart, volume)
913a982,985
>     double precision,               intent(in)    :: Struc_weight
>     double precision, dimension(6), intent(in)    :: strCart
>     double precision,               intent(in)    :: volume     
> 
930a1003,1006
>     write(ts%unit) Struc_weight
>     write(ts%unit) strCart
>     write(ts%unit) volume     
> 
945a1022,1028
>     ! Normalization for the weighted structures
>     ts%normalization = ts%normalization + Struc_weight
> 
>     if (ts%nAtomsMax < nAtoms) then
>        ts%nAtomsMax = nAtoms
>     end if     
> 
950c1033,1034
<   subroutine ts_read_structure_info(ts, filename, nAtoms, nTypes, energy)
---
>   subroutine ts_read_structure_info(ts, filename, nAtoms, nTypes, energy, &
>                                     Struc_weight, strCart, volume)
958a1043,1046
>     
>     double precision,               intent(out)   :: Struc_weight
>     double precision, dimension(6), intent(out)   :: strCart
>     double precision,               intent(out)   :: volume    
977a1066,1069
>     
>     read(ts%unit) Struc_weight
>     read(ts%unit) strCart
>     read(ts%unit) volume    
1023,1024c1115,1117
<   subroutine ts_write_sf_info(ts, nsf, sfval)
< 
---
>   subroutine ts_write_sf_info(ts, nsf, nAtoms,              &
>                               sfval, sfderiv_f, sfderiv_s) !,  &
>                               !repval, repderiv_f, repderiv_s)
1028a1122
>     integer,                            intent(in)    :: nAtoms    
1030a1125,1131
>     
>     double precision, dimension(3,nsf,nAtoms), intent(in)    :: sfderiv_f
>     double precision, dimension(6,nsf),        intent(in)    :: sfderiv_s
>     !double precision,                          intent(in)    :: repval
>     !double precision, dimension(3,nAtoms),     intent(in)    :: repderiv_f
>     !double precision, dimension(6),            intent(in)    :: repderiv_s         
> 
1034a1136
> 
1035a1138,1143
>     write(ts%unit) sfderiv_f(1:3,1:nsf,1:nAtoms)
>     write(ts%unit) sfderiv_s(1:6,1:nsf)
> 
>     !write(ts%unit) repval
>     !write(ts%unit) repderiv_f(1:3,1:nAtoms)
>     !write(ts%unit) repderiv_s(1:6)         
1057c1165,1167
<   subroutine ts_read_sf_values(ts, nsf, sfval)
---
>   subroutine ts_read_sf_values(ts, nsf, nAtoms,             &
>                                sfval, sfderiv_f, sfderiv_s)! , &
>                                !repval, repderiv_f, repderiv_s)
1062a1173
>     integer,                            intent(in)    :: nAtoms    
1063a1175,1180
>     
>     double precision, dimension(3,nsf,nAtoms), intent(out)   :: sfderiv_f
>     double precision, dimension(6,nsf),        intent(out)   :: sfderiv_s
>     !double precision,                          intent(out)   :: repval
>     !double precision, dimension(3,nAtoms),     intent(out)   :: repderiv_f
>     !double precision, dimension(6),            intent(out)   :: repderiv_s      
1068a1186,1191
>     read(ts%unit) sfderiv_f(1:3,1:nsf,1:nAtoms)
>     read(ts%unit) sfderiv_s(1:6,1:nsf)
> 
>     !read(ts%unit) repval
>     !read(ts%unit) repderiv_f(1:3,1:nAtoms)
>     !read(ts%unit) repderiv_s(1:6)       
1083a1207,1210
>     
>     double precision               :: Struc_weight
>     double precision, dimension(6) :: strCart
>     double precision               :: volume     
1086c1213,1214
<     call ts_read_structure_info(ts, filename, nAtoms, nTypes, energy)
---
>     call ts_read_structure_info(ts, filename, nAtoms, nTypes, energy, &
>                                 Struc_weight, strCart, volume)
1110c1238,1242
<        !$$ read(ts%unit) ! stp%sfderiv_i(1:3,1:stp%nsf)
---
>        read(ts%unit) ! sfderiv_f(1:3,1:stp%nsf,1:nAtoms)
>        read(ts%unit) ! stp%sfderiv_s(1:6,1:stp%nsf)
>        !read(ts%unit) ! stp%repval(1:stp%nsf)
>        !read(ts%unit) ! repderiv_f(1:3,1:stp%nsf,1:nAtoms)
>        !read(ts%unit) ! stp%repderiv_s(1:6,1:stp%nsf)  
1173a1306,1316
>     double precision, dimension(6)                  :: strCart
>     double precision                                :: Struc_weight
>     double precision                                :: volume
> 
>     double precision, dimension(:,:,:), allocatable :: sfderiv_f
>     double precision, dimension(:,:),   allocatable :: sfderiv_s
> 
>     double precision                                :: repval    
>     double precision, dimension(:,:),   allocatable :: repderiv_f
>     double precision, dimension(6)                  :: repderiv_s    
> 
1198,1199c1341,1343
<     allocate(sfval(nsf_max))
<     sfval(:) = 0.0d0
---
>     allocate(sfval(nsf_max), sfderiv_s(6,nsf_max))
>     sfval(:)       = 0.0d0
>     sfderiv_s(:,:) = 0.0d0
1214c1358,1359
<           call ts_read_structure_info(ts, filename, nAtoms, nTypes, energy)
---
>           call ts_read_structure_info(ts, filename, nAtoms, nTypes, energy, &
>                                       Struc_weight, strCart, volume)
1228c1373
< 
---
>  
1234c1379,1380
<        call ts_read_structure_info(ts, filename, nAtoms, nTypes, energy)
---
>        call ts_read_structure_info(ts, filename, nAtoms, nTypes, energy, &
>                                    Struc_weight, strCart, volume)
1235a1382
>        strCart(1:6) = scale*strCart(1:6)
1237c1384,1386
<           call ts_write_structure_info(ts2, filename, nAtoms, nTypes, energy)
---
>           call ts_write_structure_info(ts2, filename, nAtoms, nTypes, energy, &
>                                         Struc_weight, strCart, volume)
>          
1244,1246c1393,1411
<              call ts_read_sf_values(ts, nsf, sfval(1:nsf))
<              call stp_normalize(stp(itype), sfval)
<              call ts_write_sf_info(ts2, nsf, sfval(1:nsf))
---
>              allocate(sfderiv_f(3,nsf,nAtoms)) !, repderiv_f(3,nAtoms))
>              call ts_read_sf_values(ts, nsf, nAtoms, sfval(1:nsf),            &
>                                     sfderiv_f(1:3,1:nsf,1:nAtoms), sfderiv_s(1:6,1:nsf))!,  &
>                                     !repval, repderiv_f(3,nAtoms), repderiv_s(6))
>            
>              call stp_normalize(stp(itype), sfval, &
>                                 sfderiv_f=sfderiv_f, sfderiv_s=sfderiv_s, n=nAtoms)
> 
>              !confirm, acho que esta mal rep
>              !repval     = scale*(repval)
>              !repderiv_f = scale*repderiv_f
>              !repderiv_s = scale*repderiv_s
>              
>              call ts_write_sf_info(ts2, nsf, nAtoms, sfval(1:nsf),               &
>                                    sfderiv_f(1:3,1:nsf,1:nAtoms), sfderiv_s(1:6,1:nsf)) !,  &
>                                    !repval, repderiv_f(3,nAtoms), repderiv_s(6))
> 
>              deallocate(sfderiv_f) !, repderiv_f)
>  
1306a1472,1475
>     
>     double precision               :: Struc_weight
>     double precision, dimension(6) :: strCart
>     double precision               :: volume      
1321c1490,1491
<        call ts_read_structure_info(ts, filename, nAtoms, nTypes, energy)
---
>        call ts_read_structure_info(ts, filename, nAtoms, nTypes, energy, &
>                                    Struc_weight, strCart, volume)
1328c1498,1502
<           !$$ read(ts%unit) ! stp%sfderiv_i(1:3,1:stp%nsf)
---
>           read(ts%unit) ! sfderiv_f(1:3,1:stp%nsf,1:nAtoms)
>           read(ts%unit) ! stp%sfderiv_s(1:6,1:stp%nsf)
>           !read(ts%unit) ! stp%repval(1:stp%nsf)
>           !read(ts%unit) ! repderiv_f(1:3,1:nAtoms)
>           !read(ts%unit) ! stp%repderiv_s(1:6,1:stp%nsf)      
diff -r aenet-2.0.3/src/VERSION aenet-x2.0.3/src/VERSION
1c1
< 2.0.3
---
> x2.0.3
